C	BO QIN AND PROF. HARY BHADESHIA
C	2007 CML, GIFT, POSTECH. 

	PROGRAM MAIN
C	===========PARAMETERS FOR POLE FIGURES=====
	INTEGER I,J,NG
	DOUBLE PRECISION TED(3),ND(3),VOL_T,P(3),POLE(3),POLE_PLOT(12,3)
	DOUBLE PRECISION R(9),A(3),SJG(9)
	DOUBLE PRECISION XOG2T(12),YOG2T(12),XOG2M,YOG2M
	INTEGER SEL,SEL_MATRIX,SEL_ROT,SIG
	INTEGER POLE_INDEX,NO_POLES
	DOUBLE PRECISION FLAG
	INTEGER SEL_CALTYPE,K,L,NO_VIR,EULER_TYPE,K_IND
C	===========PARAMETERS FOR STRAIN===========
	DOUBLE PRECISION T1(9),T2(9),T3(9),T4(9),T5(9),T6(9),
     &                   T7(9),T8(9),T9(9),T10(9),T11(9),T12(9),TMAX(9)
	DOUBLE PRECISION H1(3),H2(3),H3(3),H4(3),
     & 	                 U1(3),U2(3),U3(3),U4(3),U5(3),U6(3),U7(3),
     & 	                 U8(3),U9(3),U10(3),U11(3),U12(3),MAG,MAGA,MAGB
	DOUBLE PRECISION ELONG
	DOUBLE PRECISION HA(12,3),UA(12,3),TA(12,9),MJTA(12,9)
	INTEGER MAXCOUNT
	DOUBLE PRECISION FCOV(3,3),FFIN(3,3),R_INV(9),VOL(12),
     &		         PTRANS(3,3),AFIN(3),ACOV(3)
     	CHARACTER *2 FINAL_CHECK, TENSOR_CHECK, VOL_INDEX
C	===========PARAMETERS FOR EULER ANGLES=====
	DOUBLE PRECISION PHI_MAT,PHI_MAT_1,PHI_MAT_2
	DOUBLE PRECISION PHI(12),PHI_1(12),PHI_2(12)
C	===========TEMP ASSIGNMENT====
	DOUBLE PRECISION DETER, DETER_INV
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	DOUBLE PRECISION TENSOR(9),SJG_INV(9),TENSOR_1(9),TENSOR_2(9)
	DOUBLE PRECISION FLG,FIBER_TED_1,FIBER_TED_2,COD_IND,TED_IND
	DOUBLE PRECISION HOT_IND
	DOUBLE PRECISION ROT_ANGLE,ELONG_NEW(3)
	INTEGER CAL_CYCLE,CAL_CYCLE_NUMBER
	DOUBLE PRECISION MAXIMUM_ROT_ANGLE,ANGLE_INTERVAL
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC		
C	============PARAMETER ASSIGN FINISHED======	
C 	===========DISPLAY PROGRAM INFORMATION=====
	WRITE (*,1)
1	FORMAT (
     &	/2X,'*********************************************************'
     &	/2x,'*********************************************************'
     &	/2X,'*  		TEXTURE PREDICTION 		     *'
     &	/2X,'*			  Hary Bhadeshia		     *'
     &	/2X,'*			    and Bo Qin 			     *'
     &	/2X,'*	 	 CML, GIFT, POSTECH, SOUTH KOREA    	     *'
     &	/2X,'*********************************************************'
     &  /2X,'                                                         ')
C	===========SLECT THE DEFORMATION MODE===========
51     	WRITE(*,*) '  SLECT DEFORMATION TYPE:'
       	WRITE(*,*) '    1 : TENSION ALONG [100]S'
       	WRITE(*,*) '    2 : COMPRESSION ALONG [100]S'
       	WRITE(*,*) '	3 : OTHER STRESS TENSORS'
	WRITE(*,*) '    0 : QUIT'
       	READ(*,*) SEL
C	========ASSIGN THE SING OF SCHMID FACTOR========
       	IF    (SEL .EQ. 1) THEN
       		TENSOR(1)=1
       		TENSOR(2)=0       		
       		TENSOR(3)=0
       		TENSOR(4)=0
       		TENSOR(5)=1
       		TENSOR(6)=0
       		TENSOR(7)=0
       		TENSOR(8)=0
       		TENSOR(9)=1
       		       		       		       		       		       		       		
       		SIG=1
       		
       	ELSEIF(SEL .EQ. 2) THEN
       		TENSOR(1)=1
       		TENSOR(2)=0       		
       		TENSOR(3)=0
       		TENSOR(4)=0
       		TENSOR(5)=1
       		TENSOR(6)=0
       		TENSOR(7)=0
       		TENSOR(8)=0
       		TENSOR(9)=1       
       			
       		SIG=-1
       		
	ELSEIF(SEL .EQ. 3) THEN
61		WRITE(*,*)'  PLZ INPUT THE COMPONENTS OF STRESS TENSOR'
		WRITE(*,*)'  WHICH IS DEFINED IN SAMPLE REFERENCE'
		WRITE(*,*)'  |TENSOR(1) TENSOR(2) TENSOR(3)|'
		WRITE(*,*)'  |TENSOR(4) TENSOR(5) TENSOR(6)|'
		WRITE(*,*)'  |TENSOR(7) TENSOR(8) TENSOR(9)|'		
		WRITE(*,*)'  ==============================='
		WRITE(*,*)'  PLEASE INPUT THE TENSOR(1)'
		READ(*,*) TENSOR(1)
		WRITE(*,*)'  PLEASE INPUT THE TENSOR(2)'
		READ(*,*) TENSOR(2)
		WRITE(*,*)'  PLEASE INPUT THE TENSOR(3)'
		READ(*,*) TENSOR(3)
		WRITE(*,*)'  PLEASE INPUT THE TENSOR(5)'
		READ(*,*) TENSOR(5)		
		WRITE(*,*)'  PLEASE INPUT THE TENSOR(6)'
		READ(*,*) TENSOR(6)
		WRITE(*,*)'  PLEASE INPUT THE TENSOR(9)'
		READ(*,*) TENSOR(9)		
		TENSOR(4)=TENSOR(2)					
		TENSOR(7)=TENSOR(3)
		TENSOR(8)=TENSOR(6)
		
		SIG=2
C		=====WRITE DOWN THE TENSOR====
62		WRITE(*,*) '  THE TENSOR YOU INPUTTED IS:'
		WRITE(*,57) TENSOR(1),TENSOR(2),TENSOR(3),TENSOR(4),
     &		  TENSOR(5),TENSOR(6),TENSOR(7),TENSOR(8),TENSOR(9) 
57		FORMAT(	/2X,'|', 3F9.4,'|'/ 2X,'|',3F9.4,'|'/ 2X,'|',
     &			3F9.4,'|')
     		WRITE(*,*) '  --------------------------'
     		WRITE(*,*) '  IS THAT CORRECT?'
     		WRITE(*,*) '  Y: YES AND CONTINUE'
     		WRITE(*,*) '  N: NO I WANT TO CHANGE'
     		READ(*,*) TENSOR_CHECK
     		IF (TENSOR_CHECK .EQ. 'Y') THEN
     		  GOTO 70
     		ELSEIF (TENSOR_CHECK .EQ. 'N') THEN
     		  GOTO 61
     		ELSE
     		  WRITE(*,*) 'WRONG INPUT!!!!'
     		  GOTO 62
     		ENDIF
C		=====WRITE DOWN THE TENSOR====

       	ELSEIF(SEL .EQ. 0) THEN
		GOTO 50
       	ELSE
       		WRITE(*,*) '  WRONG INPUT!!!'
       		GOTO 51
       	ENDIF
C	=================================================
C	=================================================       	
C	================CHOOSE MATRIX====================
70     	WRITE(*,*) '  SLECT MATRIX TYPE:'
       	WRITE(*,*) '    1 : CUBE'
       	WRITE(*,*) '    2 : GOSS'
       	WRITE(*,*) '    3 : BRASS'
       	WRITE(*,*) '    4 : COPPER'
       	WRITE(*,*) '	5 : MULTI: Cube-Goss-Brass-Copper'
       	WRITE(*,*) '	6 : BCDC. a-FIBER: <110>//ND'
       	WRITE(*,*) '	7 : BCDC. HOT ROLLING'
       	WRITE(*,*) '	8 : BCDC. COLD ROLLING'
       	WRITE(*,*) '	9 : BCDC. TENSILE TEST'
       	WRITE(*,*) '	10: BCDC: r-FIBRE'
       	WRITE(*,*) '	11: E-ORIENTATION: (111)[110]'
       	WRITE(*,*) '    0 : RANDOM'       	
	READ(*,*) SEL_MATRIX
C	=======RANDOMLY MATRIX=========
	IF (SEL_MATRIX .EQ. 0) THEN
		TED(1)=1
		TED(2)=0
		TED(3)=0
		ND(1)=0
		ND(2)=0
		ND(3)=1
		SEL_ROT=0
	  OPEN (UNIT = 11, FILE = 'STRAIN-RANDOM.TXT', STATUS = 'NEW')
C	======MATRIX WITH CUBE TEXTURE====
	ELSEIF (SEL_MATRIX .EQ. 1) THEN
		TED(1)=1
		TED(2)=0
		TED(3)=0
		ND(1)=0
		ND(2)=0
		ND(3)=1
		SEL_ROT=1
	  OPEN (UNIT = 11, FILE = 'STRAIN-CUBE.TXT', STATUS = 'NEW')		
C	======MATRIX WITH GOSS TEXTURE====
	ELSEIF (SEL_MATRIX .EQ. 2) THEN
		TED(1)=0
		TED(2)=0
		TED(3)=1
		ND(1)=1
		ND(2)=1
		ND(3)=0
	  OPEN (UNIT = 11, FILE = 'STRAIN-GOSS.TXT', STATUS = 'NEW')		
		SEL_ROT=1
C	======MATRIX WITH BRASS TEXTURE====
	ELSEIF (SEL_MATRIX .EQ. 3) THEN
C		TED(1)=1
C		TED(2)=1
C		TED(3)=2
C		ND(1)=1
C		ND(2)=-1
C		ND(3)=0
		SEL_ROT=1
	  OPEN (UNIT = 11, FILE = 'STRAIN-BRASS.TXT', STATUS = 'NEW')
		GOTO 60
C	======MATRIX WITH COPPER TEXTURE====	
	ELSEIF (SEL_MATRIX .EQ. 4) THEN
	
		TED(1)=1
		TED(2)=1
		TED(3)=-1
		ND(1)=1
		ND(2)=1
		ND(3)=2
		SEL_ROT=1
	  OPEN (UNIT = 11, FILE = 'STRAIN-COPPER.TXT', STATUS = 'NEW')		
C	======MULTI-TEXTURED MATRIX======	
	ELSEIF (SEL_MATRIX .EQ. 5) THEN
		SEL_ROT=1
		GOTO 60	
C	======a-FIBER-TEXTURED MATRIX======	
	ELSEIF (SEL_MATRIX .EQ. 6) THEN
		SEL_ROT=1
	  OPEN (UNIT = 11, FILE = 'a-FIBRE.TXT', STATUS = 'NEW')
		GOTO 60	
C	======HOT ROLLING MATRIX======	
	ELSEIF (SEL_MATRIX .EQ. 7) THEN
		SEL_ROT=1
		GOTO 60			
C	======COLD ROLLING MATRIX======	
	ELSEIF (SEL_MATRIX .EQ. 8) THEN
		SEL_ROT=1
		GOTO 60			
C	======TENSILE TEST MATRIX======	
	ELSEIF (SEL_MATRIX .EQ. 9) THEN
		SEL_ROT=1
		GOTO 60	
C	======TENSILE TEST MATRIX======	
	ELSEIF (SEL_MATRIX .EQ. 10) THEN
		SEL_ROT=1
		GOTO 60			
C	======MATRIX WITH E-ORIENTAITON TEXTURE====
	ELSEIF (SEL_MATRIX .EQ. 11) THEN
		TED(1)=1
		TED(2)=1
		TED(3)=0
		ND(1)=1
		ND(2)=-1
		ND(3)=1
		SEL_ROT=1
	  OPEN (UNIT = 11, FILE = 'STRAIN-E.TXT', STATUS = 'NEW')		
C	======MATRIX WITH GOSS TEXTURE====		
C	====================================
	ELSE
		WRITE(*,*) '  WRONG INPUTE!!!!'
		GOTO 70
	ENDIF
	
C	===============================================
	CALL NORM(TED)
	CALL NORM(ND)
C	=============FORMAT OF OUTPUT FILES============
111	FORMAT (F16.9,2X,F16.9,2X,F16.9,2X,F16.9)
112	FORMAT (F8.4,2X,F8.4,2X,F8.4)
C	==========READ IN THE MAXIMUM ROTATION ANGLE============
60	IF (SEL_ROT .EQ. 1) THEN
		WRITE(*,*) '  WHAT IS THE MAXIMUM_ROTATION_ANGLE?'
		WRITE(*,*) '  FOR INSTANCE: 0.000001, 1 , 180...'
		READ(*,*) MAXIMUM_ROT_ANGLE
		WRITE(*,*) '  WHAT IS THE ANGLE INTERVAL'
		WRITE(*,*) '  FOR INSTANCE: 1; 0.1; 0.01; 0.000.....1'
		WRITE(*,*) '  MUST SMALLER THAN MAXIMUM_ROTATION_ANGLE'
		READ(*,*) ANGLE_INTERVAL
		
		CAL_CYCLE_NUMBER=INT(MAXIMUM_ROT_ANGLE/ANGLE_INTERVAL)
	ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC      	
C	===========SELECT THE EULER SPACE TYPE==========
C	WRITE(*,*) '  FULL EULER SPACE or 45 SECTION?'
C	WRITE(*,*) '	1 : FULL EULER SPACE'
C	WRITE(*,*) '	2 : 45 SECTION'
C	READ(*,*) EULER_TYPE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	=======CHOOSE POLE FIGURE YOU WANT TO CALCULATE=========			
C	WRITE(*,*) '  WHICH POLE FIGURE DO YOU WANT TO CALCULATE?'
C	WRITE(*,*) '  FOR (100) POLE FIG PUT 100 :'
C	WRITE(*,*) '  FOR (110) POLE FIG PUT 110 :'
C	WRITE(*,*) '  FOR (111) POLE FIG PUT 111 :'
C	READ(*,*) POLE_INDEX
C	==============DEFINE THE POLES=================
C	IF (POLE_INDEX .EQ. 100) THEN
C
C	     NO_POLES = 6
C
C	     POLE_PLOT(1,1)=1
C	     POLE_PLOT(1,2)=0
C	     POLE_PLOT(1,3)=0
C	
C	     POLE_PLOT(2,1)=0
C	     POLE_PLOT(2,2)=1
C	     POLE_PLOT(2,3)=0
	
C	     POLE_PLOT(3,1)=0
C	     POLE_PLOT(3,2)=0
C	     POLE_PLOT(3,3)=1
C	
C	     POLE_PLOT(4,1)=-1
C	     POLE_PLOT(4,2)=0
C	     POLE_PLOT(4,3)=0
C		
C	     POLE_PLOT(5,1)=0
C	     POLE_PLOT(5,2)=-1
C	     POLE_PLOT(5,3)=0
C		
C	     POLE_PLOT(6,1)=0
C	     POLE_PLOT(6,2)=0
C	     POLE_PLOT(6,3)=-1
CC	=============110==================
C	ELSE IF (POLE_INDEX .EQ. 110) THEN
C
C	     NO_POLES = 12
C
C             POLE_PLOT(1,1)=1
C             POLE_PLOT(1,2)=1
C             POLE_PLOT(1,3)=0
C        
C             POLE_PLOT(2,1)=-1
C             POLE_PLOT(2,2)=1
C             POLE_PLOT(2,3)=0
C             
C             POLE_PLOT(3,1)=1
C             POLE_PLOT(3,2)=-1
C             POLE_PLOT(3,3)=0
C        	
C             POLE_PLOT(4,1)=-1
C C            POLE_PLOT(4,2)=-1
C             POLE_PLOT(4,3)=0
        	
C             POLE_PLOT(5,1)=1
C             POLE_PLOT(5,2)=0
C             POLE_PLOT(5,3)=1
C        	
C             POLE_PLOT(6,1)=-1
C             POLE_PLOT(6,2)=0
C             POLE_PLOT(6,3)=1
C        	
C             POLE_PLOT(7,1)=1
C             POLE_PLOT(7,2)=0
C             POLE_PLOT(7,3)=-1
C        	
C             POLE_PLOT(8,1)=-1
C             POLE_PLOT(8,2)=0
C             POLE_PLOT(8,3)=-1
C        	
C             POLE_PLOT(9,1)=0
C             POLE_PLOT(9,2)=-1
C             POLE_PLOT(9,3)=-1
C        	
C             POLE_PLOT(10,1)=0
C             POLE_PLOT(10,2)=1
C             POLE_PLOT(10,3)=1
C        	
C C            POLE_PLOT(11,1)=0
C             POLE_PLOT(11,2)=-1
C             POLE_PLOT(11,3)=1
CC        	
C             POLE_PLOT(12,1)=0
C             POLE_PLOT(12,2)=1
C             POLE_PLOT(12,3)=-1
CC	================111===============
C	ELSE IF (POLE_INDEX .EQ. 111) THEN

C	     NO_POLES = 8

C	     POLE_PLOT(1,1)=1
C             POLE_PLOT(1,2)=1
C             POLE_PLOT(1,3)=1
C             
C             POLE_PLOT(2,1)=-1
C             POLE_PLOT(2,2)=-1
C             POLE_PLOT(2,3)=-1
C        
C             POLE_PLOT(3,1)=-1
C             POLE_PLOT(3,2)=-1
C             POLE_PLOT(3,3)=1
C        	
C             POLE_PLOT(4,1)=1
C             POLE_PLOT(4,2)=-1
C             POLE_PLOT(4,3)=-1
C        	
C             POLE_PLOT(5,1)=-1
C             POLE_PLOT(5,2)=1
C             POLE_PLOT(5,3)=-1
C        	
C             POLE_PLOT(6,1)=1
C             POLE_PLOT(6,2)=-1
C             POLE_PLOT(6,3)=1
C        	
C             POLE_PLOT(7,1)=1
C             POLE_PLOT(7,2)=1
C             POLE_PLOT(7,3)=-1
C        	
C             POLE_PLOT(8,1)=-1
C             POLE_PLOT(8,2)=1
C             POLE_PLOT(8,3)=1 
CC	===========================C
C	ELSE 
C	  WRITE(*,*) '  WARNING INPUT!!!!'
C	  GOTO 60
C	END IF
C	================================================================
C	================================================================
C	=================MAIN CALCULATION STARTS========================
C	================================================================
	WRITE (*,*) '  PLEASE INPUT THE NUMBER OF GRAINS'
	READ (*,*) NG
C	================================================================
C 	=====FOLLOWING CODE LINES ARE FOR THE CALCULATION OF STRAINS====
C	---------------
C	===INITIALIZE FFIN===
	   DO 53 L = 1,3
	      FFIN(L,1)=0.0D+00
	      FFIN(L,2)=0.0D+00
	      FFIN(L,3)=0.0D+00
53	   CONTINUE

54	   WRITE(*,*) '  HOW MANY TWIN VARIANTS ARE OPERATING?'
	   WRITE(*,*) '  1,2,3,4,5,6,7,8,9,10,11,12'
	   READ(*,*) NO_VIR
C	---------------
	  IF((NO_VIR.NE. 1).AND.(NO_VIR .NE. 2).AND.(NO_VIR .NE. 3).AND.
     &	    (NO_VIR .NE. 4).AND.(NO_VIR .NE. 5).AND.(NO_VIR .NE. 6).AND.
     &	    (NO_VIR .NE. 7).AND.(NO_VIR .NE. 8).AND.(NO_VIR .NE. 9).AND.
     &	    (NO_VIR.NE.10).AND.(NO_VIR.NE.11).AND.(NO_VIR .NE. 12)) THEN
     	    WRITE(*,*) 'WRONG INPUT!!!'
     	    GOTO 54     
     	  ENDIF
CCCCCCCCCCCCCCCCCCCCCCC
64	  WRITE(*,*)'  ARE THEY EQUAL IN VOLUME FRACTION?'
	  WRITE(*,*)'  Y: YES, THEY ARE EQUAL.'
	  WRITE(*,*)'  N: NO, THEY HAVE NOT.'
	  READ(*,*) VOL_INDEX
	  IF (VOL_INDEX .EQ. 'Y') THEN
65	     WRITE(*,*) 'WHAT IS THE TOTAL VOLUME FRACTION? MAXIMUM IS 1'
	     READ(*,*) VOL_T
	     IF (VOL_T .GT. 1) THEN
	  	WRITE(*,*) 'WRONG INPUT'
	        GOTO 65
	     ENDIF
		DO 63 K_IND = 1, NO_VIR
		   VOL(K_IND)=VOL_T/NO_VIR
63		CONTINUE
	     GOTO 58	     
	  ELSEIF (VOL_INDEX .EQ. 'N') THEN
	     GOTO 55
	  ELSE
	     WRITE(*,*) 'WRONG INPUT!!!'
	     GOTO 64
	  ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCC     	  
C	---------------
55	    WRITE(*,*) '  TO CALCULATE THE STRAIN, PLZ INPUT THE VOLUME'
     	    WRITE(*,*) '  OF EACH TWINS, PRESS ENTER AFTER EACH INPUTE'
	  	VOL_T = 0
	    DO 56 K = 1,NO_VIR
	  	READ(*,*) VOL(K)
	  	VOL_T=VOL_T+VOL(K)
56	    CONTINUE
C	---------------
	  IF (VOL_T .GT. 1) THEN
	  	WRITE(*,*) 'WRONG INPUT'
	  	GOTO 55
	  ENDIF
C	---------------	
C	================================================================
58	WRITE(*,*) '  MAKE SURE THAT YOU ARE NOT MAKING ANY ERRORS.'
	WRITE(*,*) '  Y: ALL INPUT PARAMETERS ARE CORRECT'
	WRITE(*,*) '  N: NOT CORRECT, WANT TO INPUT AGAIN'
	READ(*,*) FINAL_CHECK
	IF ( FINAL_CHECK .EQ. 'Y') THEN
	  GOTO 59
	ELSEIF ( FINAL_CHECK .EQ. 'N') THEN
	  GOTO 51
	ELSE
	  WRITE(*,*) 'WRONG INPUT!!!'
	  GOTO 58
	ENDIF
	
C	================================================================
C 	======================OPEN THE RECORD FILES=====================
C59	IF (POLE_INDEX .EQ. 100) THEN
C	     OPEN (UNIT = 11, FILE = '100-MATRIX.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 12, FILE = '100-TWIN-01.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 13, FILE = '100-TWIN-02.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 14, FILE = '100-TWIN-03.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 15, FILE = '100-TWIN-04.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 16, FILE = '100-TWIN-05.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 17, FILE = '100-TWIN-06.TXT', STATUS = 'NEW')	
C	     OPEN (UNIT = 18, FILE = '100-TWIN-07.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 19, FILE = '100-TWIN-08.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 21, FILE = '100-TWIN-09.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 22, FILE = '100-TWIN-10.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 23, FILE = '100-TWIN-11.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 24, FILE = '100-TWIN-12.TXT', STATUS = 'NEW')
C	ELSE IF (POLE_INDEX .EQ. 110) THEN
C	     OPEN (UNIT = 11, FILE = '110-MATRIX.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 12, FILE = '110-TWIN-01.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 13, FILE = '110-TWIN-02.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 14, FILE = '110-TWIN-03.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 15, FILE = '110-TWIN-04.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 16, FILE = '110-TWIN-05.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 17, FILE = '110-TWIN-06.TXT', STATUS = 'NEW')	
C	     OPEN (UNIT = 18, FILE = '110-TWIN-07.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 19, FILE = '110-TWIN-08.TXT', STATUS = 'NEW')
CC	     OPEN (UNIT = 21, FILE = '110-TWIN-09.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 22, FILE = '110-TWIN-10.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 23, FILE = '110-TWIN-11.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 24, FILE = '110-TWIN-12.TXT', STATUS = 'NEW')
C	ELSE IF (POLE_INDEX .EQ. 111) THEN
C	     OPEN (UNIT = 11, FILE = '111-MATRIX.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 12, FILE = '111-TWIN-01.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 13, FILE = '111-TWIN-02.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 14, FILE = '111-TWIN-03.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 15, FILE = '111-TWIN-04.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 16, FILE = '111-TWIN-05.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 17, FILE = '111-TWIN-06.TXT', STATUS = 'NEW')	
CC	     OPEN (UNIT = 18, FILE = '111-TWIN-07.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 19, FILE = '111-TWIN-08.TXT', STATUS = 'NEW')
CC	     OPEN (UNIT = 21, FILE = '111-TWIN-09.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 22, FILE = '111-TWIN-10.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 23, FILE = '111-TWIN-11.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 24, FILE = '111-TWIN-12.TXT', STATUS = 'NEW')
C	ELSE
C	     WRITE(*,*) '  THERE ARE ERRORS'
C	ENDIF	     	     
C	===============OPEN FILES TO RECORD EULER ANGLES================
C	     OPEN (UNIT = 31, FILE = 'PHIS-MATRIX.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 32, FILE = 'PHIS-TWIN-01.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 33, FILE = 'PHIS-TWIN-02.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 34, FILE = 'PHIS-TWIN-03.TXT', STATUS = 'NEW')
CC	     OPEN (UNIT = 35, FILE = 'PHIS-TWIN-04.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 36, FILE = 'PHIS-TWIN-05.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 37, FILE = 'PHIS-TWIN-06.TXT', STATUS = 'NEW')	
C	     OPEN (UNIT = 38, FILE = 'PHIS-TWIN-07.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 39, FILE = 'PHIS-TWIN-08.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 41, FILE = 'PHIS-TWIN-09.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 42, FILE = 'PHIS-TWIN-10.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 43, FILE = 'PHIS-TWIN-11.TXT', STATUS = 'NEW')
C	     OPEN (UNIT = 44, FILE = 'PHIS-TWIN-12.TXT', STATUS = 'NEW')
CCC	================================================================
C	================================================================
C 	==========FIRST: CALCULATE POLE FIGURES=========================
59	DO 21 CAL_CYCLE = 1, CAL_CYCLE_NUMBER
	ROT_ANGLE=(CAL_CYCLE*1.0D+00-1.0D+00)*ANGLE_INTERVAL
	DO 20 I = 1, NG
C	WRITE (*,*) '=================================================='
C	WRITE (*,2) I
C2	FORMAT (/2X,' FOR GRAIN ', I6)
C	================================================================
C 	======SPECIAL FOR BRASS POLE FITURE=========

C		=========BRASS=============	
		IF (SEL_MATRIX .EQ. 3) THEN
		    FLAG = RAND()
		    IF (FLAG .LE. 0.5) THEN
		    	TED(1)=1
		    	TED(2)=1
		    	TED(3)=-2
			ND(1)=1
			ND(2)=-1
			ND(3)=0		    	
			CALL NORM(ND)
		    	CALL NORM(TED)
		    ELSE
		    	TED(1)=1
		    	TED(2)=1
		    	TED(3)=2
			ND(1)=1
			ND(2)=-1
			ND(3)=0
			CALL NORM(ND)		    	
		    	CALL NORM(TED)
		    ENDIF   
C		=========MULTI=============	
		ELSEIF (SEL_MATRIX .EQ. 5) THEN
		    FLG = RAND()
C		    =====CUBE====		    
		    IF ((0 .LE. FLG) .AND. (FLG .LT. 0.25)) THEN		    
			TED(1)=1
			TED(2)=0
			TED(3)=0
			ND(1)=0
			ND(2)=0
			ND(3)=1
			CALL NORM(TED)
			CALL NORM(ND)
C		    =====GOSS====			
		    ELSEIF ((0.25 .LE. FLG) .AND. (FLG .LT. 0.5)) THEN
			TED(1)=0
			TED(2)=0
			TED(3)=1
			ND(1)=1
			ND(2)=1
			ND(3)=0		    
			CALL NORM(TED)
			CALL NORM(ND)
C		    =====BRASS====			
		    ELSEIF ((0.5 .LE. FLG) .AND. (FLG .LT. 0.75)) THEN
			TED(1)=1
			TED(2)=1
			TED(3)=2
			ND(1)=1
			ND(2)=-1
			ND(3)=0		    
		        CALL NORM(TED)
		        CALL NORM(ND)
C		    =====COPPER=====			        
		    ELSE
			TED(1)=1
			TED(2)=1
			TED(3)=-1
			ND(1)=1
			ND(2)=1
			ND(3)=2
			CALL NORM(TED)
			CALL NORM(ND)
		    ENDIF

C		======a-FIBER-TEXTURED MATRIX======	
		ELSEIF (SEL_MATRIX .EQ. 6) THEN
			ND(1)=1
		    	ND(2)=1
		    	ND(3)=0
		    
		    	FIBER_TED_1=RAND()-0.5
		    	FIBER_TED_2=RAND()-0.5
		    
		    	TED(1)=FIBER_TED_1
		    	TED(2)=-1 * FIBER_TED_1
		    	TED(3)=FIBER_TED_2
		    
		    	CALL NORM(ND)
		    	CALL NORM(TED)
		    	
C		=======BCDC. HOT ROLLING===========
		ELSEIF (SEL_MATRIX .EQ. 7) THEN
		    HOT_IND = RAND()
C		    ===COPPER====
		    IF (HOT_IND .LE. 0.3) THEN
			TED(1)=1
			TED(2)=1
			TED(3)=-1
			ND(1)=1
			ND(2)=1
			ND(3)=2
			CALL NORM(TED)
			CALL NORM(ND)
C		    ===CUBE===
		    ELSEIF ((0.3.LT.HOT_IND).AND.(HOT_IND.LE.0.6)) THEN
			TED(1)=1
			TED(2)=0
			TED(3)=0
			ND(1)=0
			ND(2)=0
			ND(3)=1
			CALL NORM(TED)
			CALL NORM(ND)
C		    ===a-fiber===
		    ELSE
			ND(1)=1
		    	ND(2)=1
		    	ND(3)=0		    
		    	FIBER_TED_1=RAND()-0.5
		    	FIBER_TED_2=RAND()-0.5
		       	TED(1)=FIBER_TED_1
		    	TED(2)=-1 * FIBER_TED_1
		    	TED(3)=FIBER_TED_2
		       	CALL NORM(ND)
		    	CALL NORM(TED)	
		    ENDIF			    
C		===============CLOD ROLLING MATRIX===========
		ELSEIF (SEL_MATRIX .EQ. 8) THEN
		    COD_IND = RAND()
C		    ===COPPER===
		    IF (COD_IND .LE. 0.15) THEN
			TED(1)=1
			TED(2)=1
			TED(3)=-1
			ND(1)=1
			ND(2)=1
			ND(3)=2
			CALL NORM(TED)
			CALL NORM(ND)
C		    ===WHATEVER===
		    ELSEIF ((0.15.LT.COD_IND).AND.(COD_IND.LE.0.3)) THEN
			TED(1)=0
			TED(2)=-2
			TED(3)=1
			ND(1)=1
			ND(2)=1
			ND(3)=2
			CALL NORM(TED)
			CALL NORM(ND)			
C		    ===a-fiber===
		    ELSE
			ND(1)=1
		    	ND(2)=1
		    	ND(3)=0		    
		    	FIBER_TED_1=RAND()-0.5
		    	FIBER_TED_2=RAND()-0.5
		       	TED(1)=FIBER_TED_1
		    	TED(2)=-1 * FIBER_TED_1
		    	TED(3)=FIBER_TED_2
		       	CALL NORM(ND)
		    	CALL NORM(TED)
		    ENDIF
C		===============TENSILE MATRIX===========
		ELSEIF (SEL_MATRIX .EQ. 9) THEN
		    TED_IND = RAND()
C		    ===COPPER===
		    IF (TED_IND .LE. 0.25) THEN
			TED(1)=1
			TED(2)=1
			TED(3)=-1
			ND(1)=1
			ND(2)=1
			ND(3)=2
			CALL NORM(TED)
			CALL NORM(ND)
C		    ===CUBE===
		    ELSEIF ((0.25.LE.TED_IND).AND.(TED_IND.LE.0.5)) THEN
			TED(1)=1
			TED(2)=0
			TED(3)=0
			ND(1)=0
			ND(2)=0
			ND(3)=1
			CALL NORM(TED)
			CALL NORM(ND)			
C		    ===a-fiber===
		    ELSE
			ND(1)=1
		    	ND(2)=1
		    	ND(3)=0
		       	FIBER_TED_1=RAND()-0.5
		    	FIBER_TED_2=RAND()-0.5
		       	TED(1)=FIBER_TED_1
		    	TED(2)=-1 * FIBER_TED_1
		    	TED(3)=FIBER_TED_2
		       	CALL NORM(ND)
		    	CALL NORM(TED)
		    ENDIF
C		======a-FIBER-TEXTURED MATRIX======	
		ELSEIF (SEL_MATRIX .EQ. 10) THEN
			ND(1)=1
		    	ND(2)=1
		    	ND(3)=1
		    
		    	FIBER_TED_1=RAND()-0.5
		    	FIBER_TED_2=RAND()-0.5
		    
		    	TED(1)=FIBER_TED_1
		    	TED(2)=FIBER_TED_2
		    	TED(3)=-1.00*(FIBER_TED_1+FIBER_TED_2)
		    
		    	CALL NORM(ND)
		    	CALL NORM(TED)		    		
C		=========================
		ELSE
		  GOTO 80
		ENDIF
C 	=======SPECIAL FOR BRASS POLE FIGURE==========
C	================================================================
80	IF (I .EQ. 1) THEN
	   CALL ROT_ORI(R,A,TED)
	   DO 30 J = 1,NO_POLES
		POLE(1)=POLE_PLOT(J,1)
		POLE(2)=POLE_PLOT(J,2)
		POLE(3)=POLE_PLOT(J,3)
		CALL NORM(POLE)
C		CALL RITEPOLE(POLE)
		CALL SJGMATRIX(TED,ND,SJG)		
C		-------FOR TENSOR CALCULATION-------		
		IF (SIG .EQ. 2) THEN
		    CALL INVERSE(SJG,SJG_INV)
		    CALL SIMILARITY_MATRIX(SJG_INV,TENSOR,TENSOR_1)
		    CALL MJTMALL(MJTA,A,TENSOR_1,SIG)
		ELSE
		    CALL MJTMALL(MJTA,A,TENSOR,SIG)
		ENDIF
C		-------FOR TENSOR CALCULATION-------
		CALL TPOG2(MJTA,POLE,R,SJG,XOG2T,YOG2T)
C		WRITE (12,111) XOG2T(1),YOG2T(1)
C		WRITE (13,111) XOG2T(2),YOG2T(2)
C		WRITE (14,111) XOG2T(3),YOG2T(3)
C		WRITE (15,111) XOG2T(4),YOG2T(4)
C		WRITE (16,111) XOG2T(5),YOG2T(5)
C		WRITE (17,111) XOG2T(6),YOG2T(6)
C		WRITE (18,111) XOG2T(7),YOG2T(7)
C		WRITE (19,111) XOG2T(8),YOG2T(8)
C		WRITE (21,111) XOG2T(9),YOG2T(9)
C		WRITE (22,111) XOG2T(10),YOG2T(10)
C		WRITE (23,111) XOG2T(11),YOG2T(11)
C		WRITE (24,111) XOG2T(12),YOG2T(12)
		CALL SJGMATRIX(TED,ND,SJG)
		CALL MPOG2(A,POLE,R,SJG,XOG2M,YOG2M)
C		WRITE (11,111) XOG2M,YOG2M
30	    CONTINUE
C	================================================================
	ELSE
C	   ==============
	   IF (SEL_ROT .EQ. 0) THEN
	      CALL ROT_RAND(R,A,TED)
	   ELSE
	      CALL ROT_TEXTURED(R,A,TED,ROT_ANGLE)
	   ENDIF
C	   ==============
	   DO 40 J = 1,NO_POLES
		POLE(1)=POLE_PLOT(J,1)
		POLE(2)=POLE_PLOT(J,2)
		POLE(3)=POLE_PLOT(J,3)
		CALL NORM(POLE)
C		CALL RITEPOLE(POLE)
		CALL SJGMATRIX(TED,ND,SJG)
C		-------FOR TENSOR CALCULATION-------		
		IF (SIG .EQ. 2) THEN
		    CALL INVERSE(SJG,SJG_INV)
		    CALL SIMILARITY_MATRIX(SJG_INV,TENSOR,TENSOR_1)
		    CALL SIMILARITY_MATRIX(R,TENSOR_1,TENSOR_2)
		    CALL MJTMALL(MJTA,A,TENSOR_2,SIG)
		ELSE
		    CALL MJTMALL(MJTA,A,TENSOR,SIG)
		ENDIF
C		-------FOR TENSOR CALCULATION-------			
C		CALL MJTMALL(MJTA,A,TENSOR_1,SIG)
C		CALL MJTMALL(MJTA,A,TENSOR,SIG)
		CALL TPOG2(MJTA,POLE,R,SJG,XOG2T,YOG2T)
C		WRITE (12,111) XOG2T(1),YOG2T(1)
C		WRITE (13,111) XOG2T(2),YOG2T(2)
C		WRITE (14,111) XOG2T(3),YOG2T(3)
C		WRITE (15,111) XOG2T(4),YOG2T(4)
C		WRITE (16,111) XOG2T(5),YOG2T(5)
C		WRITE (17,111) XOG2T(6),YOG2T(6)
C		WRITE (18,111) XOG2T(7),YOG2T(7)
C		WRITE (19,111) XOG2T(8),YOG2T(8)
C		WRITE (21,111) XOG2T(9),YOG2T(9)
C		WRITE (22,111) XOG2T(10),YOG2T(10)
C		WRITE (23,111) XOG2T(11),YOG2T(11)
C		WRITE (24,111) XOG2T(12),YOG2T(12)
		CALL SJGMATRIX(TED,ND,SJG)
		CALL MPOG2(A,POLE,R,SJG,XOG2M,YOG2M)
C		WRITE (11,111) XOG2M,YOG2M
40	   CONTINUE
C	================================================================
	ENDIF
	
C	================================================================
C	================================================================
C 	==========SECOND: CALCULATE EULER ANGLES========================
C	CALL CALEULERANGLE(TED,ND,R,MJTA,PHI,PHI_1,PHI_2,
C     &		   PHI_MAT,PHI_MAT_1,PHI_MAT_2)
C		------     
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	IF     (EULER_TYPE .EQ. 1) THEN
C 	  	WRITE (31,112) PHI_MAT,PHI_MAT_1,PHI_MAT_2
C		WRITE (32,112) PHI(1),PHI_1(1),PHI_2(1)
C		WRITE (33,112) PHI(2),PHI_1(2),PHI_2(2)
C		WRITE (34,112) PHI(3),PHI_1(3),PHI_2(3)
C		WRITE (35,112) PHI(4),PHI_1(4),PHI_2(4)
C		WRITE (36,112) PHI(5),PHI_1(5),PHI_2(5)
C		WRITE (37,112) PHI(6),PHI_1(6),PHI_2(6)
C C   		WRITE (38,112) PHI(7),PHI_1(7),PHI_2(7)
C	     	WRITE (39,112) PHI(8),PHI_1(8),PHI_2(8)
C		WRITE (41,112) PHI(9),PHI_1(9),PHI_2(9)
C		WRITE (42,112) PHI(10),PHI_1(10),PHI_2(10)
C C    		WRITE (43,112) PHI(11),PHI_1(11),PHI_2(11)
C	     	WRITE (44,112) PHI(12),PHI_1(12),PHI_2(12)
CCCCCCCC
C	ELSEIF  (EULER_TYPE .EQ. 2) THEN
C		------     
C     		IF ((40.LE.PHI_MAT_2).AND.(PHI_MAT_2.LE.45)) THEN
C     			WRITE (31,112) PHI_MAT,PHI_MAT_1,PHI_MAT_2
C     		ENDIF
C     		------
C     		IF ((40.LE.PHI_2(1)).AND.(PHI_2(1).LE.45)) THEN
C     			WRITE (32,112) PHI(1),PHI_1(1),PHI_2(1)
C     		ENDIF
C		------     		
C     		IF ((40.LE.PHI_2(2)).AND.(PHI_2(2).LE.45)) THEN
C			WRITE (33,112) PHI(2),PHI_1(2),PHI_2(2)
C		ENDIF
C		------
C     		IF ((40.LE.PHI_2(3)).AND.(PHI_2(3).LE.45)) THEN	
C			WRITE (34,112) PHI(3),PHI_1(3),PHI_2(3)
C		ENDIF
C		------
C     		IF ((40.LE.PHI_2(4)).AND.(PHI_2(4).LE.45)) THEN		
C			WRITE (35,112) PHI(4),PHI_1(4),PHI_2(4)
C		ENDIF
C		------
C     		IF ((40.LE.PHI_2(5)).AND.(PHI_2(5).LE.45)) THEN
C			WRITE (36,112) PHI(5),PHI_1(5),PHI_2(5)
C		ENDIF
C		------
C     		IF ((40.LE.PHI_2(6)).AND.(PHI_2(6).LE.45)) THEN		
C			WRITE (37,112) PHI(6),PHI_1(6),PHI_2(6)
C		ENDIF
C		------
C     		IF ((40.LE.PHI_2(7)).AND.(PHI_2(7).LE.45)) THEN		
C     			WRITE (38,112) PHI(7),PHI_1(7),PHI_2(7)
C		ENDIF
C		------
C     		IF ((40.LE.PHI_2(8)).AND.(PHI_2(8).LE.45)) THEN
C     			WRITE (39,112) PHI(8),PHI_1(8),PHI_2(8)
C     		ENDIF
C     		------
C     		IF ((40.LE.PHI_2(9)).AND.(PHI_2(9).LE.45)) THEN
C			WRITE (41,112) PHI(9),PHI_1(9),PHI_2(9)
C		ENDIF
C		------
C     		IF ((40.LE.PHI_2(10)).AND.(PHI_2(10).LE.45)) THEN		
C			WRITE (42,112) PHI(10),PHI_1(10),PHI_2(10)
C		ENDIF
C		------
C     		IF ((40.LE.PHI_2(11)).AND.(PHI_2(11).LE.45)) THEN		
C     			WRITE (43,112) PHI(11),PHI_1(11),PHI_2(11)
C     		ENDIF
C		------
C     		IF ((40.LE.PHI_2(12)).AND.(PHI_2(12).LE.45)) THEN
C     			WRITE (44,112) PHI(12),PHI_1(12),PHI_2(12)
C     		ENDIF
C     	ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	================================================================
C	================================================================
C 	==============THIRD: CALCULATE STRAINS==========================
C
C	CALL FIND_PTRANS(R,PTRANS,TED,ND)
	CALL SJGMATRIX(TED,ND,SJG)
	CALL FIND_PTRANS(R,PTRANS,SJG)
	CALL INVERSE(R,R_INV)
C		-------FOR TENSOR CALCULATION-------		
		IF (SIG .EQ. 2) THEN
		    CALL INVERSE(SJG,SJG_INV)
		    CALL SIMILARITY_MATRIX(SJG_INV,TENSOR,TENSOR_1)
		    CALL SIMILARITY_MATRIX(R,TENSOR_1,TENSOR_2)		    
		    CALL TWIN(TA,A,TENSOR_2,SIG)
		ELSE
		    CALL TWIN(TA,A,TENSOR_2,SIG)
		ENDIF
C		-------FOR TENSOR CALCULATION-------	
C	CALL TWIN(TA,A,SIG)
     	CALL FCOVRT(TA,R_INV,FCOV,VOL,PTRANS,NO_VIR,VOL_T,SJG)
     	CALL FFINAL(FFIN,FCOV)
C	CALL STRAIN(FFIN,I)
C	================================================================
C	WRITE (*,3) I
C3	FORMAT (/2X,' GRAIN', I6, '  COMPLETED')
C
20	CONTINUE
	CALL STRAIN(FFIN,NG,ELONG_NEW)
	WRITE (11,111) ROT_ANGLE,ELONG_NEW(1),ELONG_NEW(2),ELONG_NEW(3)
	FFIN(1,1)=0.0*D+00
	FFIN(1,2)=0.0*D+00
	FFIN(1,3)=0.0*D+00
	FFIN(2,1)=0.0*D+00
	FFIN(2,2)=0.0*D+00
	FFIN(2,3)=0.0*D+00
	FFIN(3,1)=0.0*D+00
	FFIN(3,2)=0.0*D+00
	FFIN(3,3)=0.0*D+00								
21	CONTINUE
C	======Exit the main program==========
50	CONTINUE
	STOP
	END


C =====================================================================================
C =====================================================================================
C =====================================================================================

C Subroutine to get the coordinate transformation matrix,
C 	which converts the vector components between sample reference and grain reference
C 'SJGMATRIX': Matrix which transforms components of a vector in grain to components in 
C	Sample reference
C 'G' represents the Grain reference
C 'S' represents the sample reference
C 'SJG': stands for Transforming Grain reference to Sample reference; Components of 'SJG'
C 'GINV': Components of inverse of matrix G
C for instance [1 -1 2]G//[1 0 0]S//TED; [1 -1 -1]G//[0 1 0]S//TED; [1 1 0]G//[0 0 1]S//ND

C |S(1) S(2) S(3)|	   |G(1) G(2) G(3)|   |SJG(1) SJG(2) SJG(3)| |G(1) G(2) G(3)|
C |S(4) S(5) S(6)| = (SJG)*|G(4) G(5) G(6)| = |SJG(4) SJG(5) SJG(6)|*|G(4) G(5) G(6)|
C |S(7) S(8) S(9)|	   |G(7) G(8) G(9)|   |SJG(7) SJG(8) SJG(9)| |G(7) G(8) G(9)|
C
C |SJG(1) SJG(2) SJG(3)| |S(1) S(2) S(3)| |GINV(1) GINV(2) GINV(3)|
C |SJG(4) SJG(5) SJG(6)|=|S(4) S(5) S(6)|*|GINV(4) GINV(5) GINV(6)|
C |SJG(7) SJG(8) SJG(9)| |S(7) S(8) S(9)| |GINV(7) GINV(8) GINV(9)|

C INPUT PARAMETERS: G,S
C OUTPUT PARAMETERS: SJG, which are components of SJGMATRIX

	SUBROUTINE SJGMATRIX(TED,ND,SJG)
C Argument declarations
	DOUBLE PRECISION TED(3),ND(3),SJG(9)
	
C Local declarations
	DOUBLE PRECISION GINV(9),TD(3),S(9),G(9)
C
	TD(1)=TED(2)*ND(3)-TED(3)*ND(2)
	TD(2)=TED(3)*ND(1)-TED(1)*ND(3)
	TD(3)=TED(1)*ND(2)-TED(2)*ND(1)
C-------------------------------------------------
	CALL NORM(TED)
	CALL NORM(ND)
	CALL NORM(TD)
C-------------------------------------------------
	S(1)=1
	S(2)=0
	S(3)=0
	S(4)=0
	S(5)=1
	S(6)=0
	S(7)=0
	S(8)=0
	S(9)=1
C-------------------------------------------------
	G(1)=TED(1)
	G(2)=TD(1)
	G(3)=ND(1)
	G(4)=TED(2)
	G(5)=TD(2)
	G(6)=ND(2)
	G(7)=TED(3)
	G(8)=TD(3)
	G(9)=ND(3)
C
	CALL INVERSE(G,GINV)

	SJG(1)=S(1)*GINV(1)+S(2)*GINV(4)+S(3)*GINV(7)
	SJG(2)=S(1)*GINV(2)+S(2)*GINV(5)+S(3)*GINV(8)
	SJG(3)=S(1)*GINV(3)+S(2)*GINV(6)+S(3)*GINV(9)
	SJG(4)=S(4)*GINV(1)+S(5)*GINV(4)+S(6)*GINV(7)
	SJG(5)=S(4)*GINV(2)+S(5)*GINV(5)+S(6)*GINV(8)
	SJG(6)=S(4)*GINV(3)+S(5)*GINV(6)+S(6)*GINV(9)
	SJG(7)=S(7)*GINV(1)+S(8)*GINV(4)+S(9)*GINV(7)
	SJG(8)=S(7)*GINV(2)+S(8)*GINV(5)+S(9)*GINV(8)
	SJG(9)=S(7)*GINV(3)+S(8)*GINV(6)+S(9)*GINV(9)

C	WRITE (*,10) SJG(1),SJG(2),SJG(3),SJG(4),SJG(5),SJG(6),
C     &		     SJG(7),SJG(8),SJG(9)
C10	FORMAT (/ 2x,'coordinate trans. matrix between grain and sample'
C     &		/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')
C
	RETURN
	END


C========================================================================================
C========================================================================================
C Subroutine to convert vectors in Grain reference to Sample reference
C
C	|V(1)|	 |SJG(1) SJG(2) SJG(3)|	  |POLE(1)|
C	|V(2)| = |SJG(4) SJG(5) SJG(6)| * |POLE(2)|
C	|V(3)|	 |SJG(7) SJG(8) SJG(9)|	  |POLE(3)|
C 'V' Components of vector POLE, whose components were [pole(1) pole(2) pole(3)] 
C	in grain basis initially, now in Sample basis
C 
C INPUT PARAMETER: SJG, POLE
C OUTPUT PARAMETER: V

	SUBROUTINE SJGVECTOR(SJG,POLE,V)
C Argument declarations
	DOUBLE PRECISION SJG(9),POLE(3),V(3),LENGTH
C	
		V(1)=SJG(1)*POLE(1)+SJG(2)*POLE(2)+SJG(3)*POLE(3)
		V(2)=SJG(4)*POLE(1)+SJG(5)*POLE(2)+SJG(6)*POLE(3)
		V(3)=SJG(7)*POLE(1)+SJG(8)*POLE(2)+SJG(9)*POLE(3)
C Check the length of vector [V(1),V(2),V(3)]
C		LENGTH = V(1)*V(1)+V(2)*V(2)+V(3)*V(3)
C
C	WRITE(*,10) V(1),V(2),V(3),LENGTH
C10	FORMAT (/2X, 'vector POLE in sample reference: ','(',3F8.4,')',2X,'LENGTH=',F8.6)
	RETURN
	END

C=========================================================================================
C=========================================================================================
C Subroutine to convert 3D representation of vector pole into 2D representation
C 
C 'TDTTD': Three Dimension To Two Dimension
C 'X': Abscissa of poles (2D representation)
C 'Y': Ordinate of poles (2D representation)
C 'MOT': Matrix or Twin
C
C INPUT PARAMETER: V,MOT
C OUTPUT PARAMETER: X and Y
C
	SUBROUTINE TDTTD(MOT,V,X,Y)
C Augument declaration
	DOUBLE PRECISION V(3),X,Y
	CHARACTER *10 MOT
C
	IF (V(3) .GT. 0) THEN
		X = V(1)/(1+V(3))
		Y = V(2)/(1+V(3))
	  ELSE
		X = V(1)/(1-V(3))
		Y = V(2)/(1-V(3))
	ENDIF
C	
C	WRITE(*,10) MOT,X,Y
C10	FORMAT (2X, 'for ',A10,' pole of vector POLE in 2D representation: ','(',2F8.4,')')
	RETURN
	END

C==========================================================================================
C==========================================================================================
C Subroutine to normalise the components of a vector
C 'A' is a vector
C 'MAG' is its magnitude
C
	SUBROUTINE NORM(A)
	DOUBLE PRECISION A(3),XTEMP,YTEMP,ZTEMP,MAG
C
		XTEMP=A(1)
		YTEMP=A(2)
		ZTEMP=A(3)
        MAG=DSQRT(XTEMP*XTEMP+YTEMP*YTEMP+ZTEMP*ZTEMP)
        XTEMP=XTEMP/MAG
        YTEMP=YTEMP/MAG
        ZTEMP=ZTEMP/MAG
        A(1)=XTEMP
        A(2)=YTEMP
        A(3)=ZTEMP
C
      RETURN
      END

C==========================================================================================
C==========================================================================================
C Subroutine to calculate matrix twin coordinate transformation matrix MJT
C 'MJT': Matrix Twin coordinate transformation matrix
C 'H': Normal of Twinning Plane in Matrix
C 'HT': Normal of Twinning plane in twin
C 'U': Twinning Direction
C 'S': Section Plane Normal
C 'INV': means inverse of matrix
C |S(1) U(1) H(1)|	 |S(1) U(1) HT(1)| |MJT(1) MJT(2) MJT(3)| |S(1) U(1) HT(1)|
C |S(2) U(2) H(2)|=(MJT)*|S(2) U(2) HT(2)|=|MJT(4) MJT(5) MJT(6)|*|S(2) U(2) HT(2)|
C |S(3) U(3) H(3)|	 |S(3) U(3) HT(3)| |MJT(7) MJT(8) MJT(9)| |S(3) U(3) HT(3)|
C									||
C                                                          |TEMP(1) TEMP(2) TEMP(3)|
C                                                          |TEMP(4) TEMP(5) TEMP(6)|
C                                                          |TEMP(7) TEMP(8) TEMP(9)|
C
C
C	|MJT(1) MJT(2) MJT(3)| |S(1) U(1) H(1)| |SINV(1) UINV(1) HTINV(1)|
C (MJT)=|MJT(4) MJT(5) MJT(6)|=|S(2) U(2) H(2)|*|SINV(2) UINV(2) HTINV(2)|
C	|MJT(7) MJT(8) MJT(9)| |S(3) U(3) H(3)| |SINV(3) UINV(3) HTINV(3)|
C							    ||
C					    |TEMPINV(1) TEMPINV(2) TEMPINV(3)|
C					    |TEMPINV(4) TEMPINV(5) TEMPINV(6)|
C					    |TEMPINV(7) TEMPINV(8) TEMPINV(9)|
C
C
C INPUT PARAMETERS: H,HT,S,U
C OUTPUT PARAMETERS: MJT
	SUBROUTINE MJTMATRIX(MJT,H,HT,U,S)
C Argument declarations
	DOUBLE PRECISION MJT(9),S(3),U(3),H(3),HT(3)
C Local declaration
	DOUBLE PRECISION TEMP(9),TEMPINV(9)
	
	TEMP(1)=S(1)
	TEMP(2)=U(1)
	TEMP(3)=HT(1)
		
	TEMP(4)=S(2)
	TEMP(5)=U(2)
	TEMP(6)=HT(2)
		
	TEMP(7)=S(3)
	TEMP(8)=U(3)
	TEMP(9)=HT(3)

	CALL INVERSE(TEMP,TEMPINV)

	MJT(1)=S(1)*TEMPINV(1)+U(1)*TEMPINV(4)+H(1)*TEMPINV(7)
	MJT(2)=S(1)*TEMPINV(2)+U(1)*TEMPINV(5)+H(1)*TEMPINV(8)
	MJT(3)=S(1)*TEMPINV(3)+U(1)*TEMPINV(6)+H(1)*TEMPINV(9)
C
	MJT(4)=S(2)*TEMPINV(1)+U(2)*TEMPINV(4)+H(2)*TEMPINV(7)
	MJT(5)=S(2)*TEMPINV(2)+U(2)*TEMPINV(5)+H(2)*TEMPINV(8)
	MJT(6)=S(2)*TEMPINV(3)+U(2)*TEMPINV(6)+H(2)*TEMPINV(9)
C
	MJT(7)=S(3)*TEMPINV(1)+U(3)*TEMPINV(4)+H(3)*TEMPINV(7)
	MJT(8)=S(3)*TEMPINV(2)+U(3)*TEMPINV(5)+H(3)*TEMPINV(8)
	MJT(9)=S(3)*TEMPINV(3)+U(3)*TEMPINV(6)+H(3)*TEMPINV(9)
C	
	RETURN
	END

C==========================================================================================
C==========================================================================================
C Subroutine to calculate the matrix twin coordinate transformation matrix
C 'MJT': Matrix Twin coordinate transformation matrix
C 'H': Normal of Twinning Plane in Matrix
C 'HT': Normal of Twinning plane in twin
C 'U': Twinning Direction
C 'S': Section Plane Normal
C 'MJTA': MJT array
C 'A': tensile axis with respect to local grain coordinate



	SUBROUTINE MJTMALL(MJTA,A,TENSOR,SIG)

C Argument Declarations
	DOUBLE PRECISION MJT1(9),MJT2(9),MJT3(9),MJT4(9),MJT5(9),
     &	MJT6(9),MJT7(9),MJT8(9),MJT9(9),MJT10(9),MJT11(9),MJT12(9),
     &	H1(3),H2(3),H3(3),H4(3),HT1(3),HT2(3),HT3(3),HT4(3),
     &  U1(3),U2(3),U3(3),U4(3),U5(3),U6(3),U7(3),U8(3),U9(3),
     &	U10(3),U11(3),U12(3),S1(3),S2(3),S3(3),S4(3),S5(3),S6(3),S7(3),
     &	S8(3),S9(3),S10(3),S11(3),S12(3),MJTA(12,9),A(3)
C Local Declarations
	DOUBLE PRECISION SMF(12),HA(12,3),UA(12,3)
	INTEGER I,MAXCOUNT,SIG
	DOUBLE PRECISION TENSOR(9)
C====================================
C Define twin plane normals in matrix	
	H1(1)=1
	H1(2)=1
	H1(3)=1
C
	H2(1)=1
	H2(2)=-1
	H2(3)=-1
C  
	H3(1)=-1
	H3(2)=1
	H3(3)=-1
C
	H4(1)=-1
	H4(2)=-1
	H4(3)=1
C=====================================
C Define twin plane normals in twin
	HT1(1)=-1
	HT1(2)=-1
	HT1(3)=-1
C
	HT2(1)=-1
	HT2(2)=1
	HT2(3)=1
C  
	HT3(1)=1
	HT3(2)=-1
	HT3(3)=1
C
	HT4(1)=1
	HT4(2)=1
	HT4(3)=-1

C=========================================================
C Define twin directions and section plane normal in (111)
CCCCCCCCCCCCCCCCCCCCCCCCCC	 
	U1(1)=1
	U1(2)=1
	U1(3)=-2
C
	S1(1)=-1
	S1(2)=1
	S1(3)=0

CCCCCCCCCCCCCCCCCCCCCCCCCC
	U2(1)=1
	U2(2)=-2
	U2(3)=1
C
	S2(1)=-1
	S2(2)=0
	S2(3)=1
CCCCCCCCCCCCCCCCCCCCCCCCCC
	U3(1)=-2
	U3(2)=1
	U3(3)=1
C
	S3(1)=0
	S3(2)=-1
	S3(3)=1
C===========================================================
C Define twin directions and section plane normal in (1-1-1) 
CCCCCCCCCCCCCCCCCCCCCCCCCCC
	U4(1)=1
	U4(2)=2
	U4(3)=-1
C
	S4(1)=1
	S4(2)=0
	S4(3)=1
CCCCCCCCCCCCCCCCCCCCCCCCCCC	 
	U5(1)=1
	U5(2)=-1
	U5(3)=2
C
	S5(1)=1
	S5(2)=1
	S5(3)=0
CCCCCCCCCCCCCCCCCCCCCCCCCCC
	U6(1)=-2
	U6(2)=-1
	U6(3)=-1
C
	S6(1)=0
	S6(2)=-1
	S6(3)=1
C=============================================================
C Define twin directions and section plane normal in (-11-1) 
CCCCCCCCCCCCCCCCCCCCCCCCCCC	 
	U7(1)=-1
	U7(2)=-2
	U7(3)=-1
C
	S7(1)=-1
	S7(2)=0
	S7(3)=1
CCCCCCCCCCCCCCCCCCCCCCCCCCC	 
	U8(1)=-1
	U8(2)=1
	U8(3)=2
C
	S8(1)=1
	S8(2)=1
	S8(3)=0
CCCCCCCCCCCCCCCCCCCCCCCCCCC	 
	U9(1)=2
	U9(2)=1
	U9(3)=-1
C
	S9(1)=0
	S9(2)=1
	S9(3)=1
C==============================================================
C Define twin directions and section plane normal in (-1-11) 
CCCCCCCCCCCCCCCCCCCCCCCCCCC
	U10(1)=-1
	U10(2)=-1
	U10(3)=-2
C
	S10(1)=1
	S10(2)=-1
	S10(3)=0
CCCCCCCCCCCCCCCCCCCCCCCCCCC	 
	U11(1)=-1
	U11(2)=2
	U11(3)=1
C
	S11(1)=1
	S11(2)=0
	S11(3)=1
CCCCCCCCCCCCCCCCCCCCCCCCCCC	 
	U12(1)=2
	U12(2)=-1
	U12(3)=1
C
	S12(1)=0
	S12(2)=1
	S12(3)=1
C===========================================================
C Normalise everything to unit vectors
C Actually we don't have to do this
	 CALL NORM(H1)
	 CALL NORM(H2)
	 CALL NORM(H3)
	 CALL NORM(H4)
 	 CALL NORM(HT1)
	 CALL NORM(HT2)
	 CALL NORM(HT3)
	 CALL NORM(HT4)
C
	 CALL NORM(U1) 	 	
	 CALL NORM(U2) 
	 CALL NORM(U3) 	
	 CALL NORM(S1) 	 	
	 CALL NORM(S2) 
	 CALL NORM(S3) 
C	 	 	 	 
	 CALL NORM(U4) 	 	
	 CALL NORM(U5) 
	 CALL NORM(U6) 	 	 	 
	 CALL NORM(S4) 	 	
	 CALL NORM(S5) 
	 CALL NORM(S6)
C
	 CALL NORM(U7) 	 	
	 CALL NORM(U8) 
	 CALL NORM(U9) 
	 CALL NORM(S7) 	 	
	 CALL NORM(S8) 
	 CALL NORM(S9)
C
	 CALL NORM(U10) 	 	
	 CALL NORM(U11) 
	 CALL NORM(U12) 	
	 CALL NORM(S10) 	 	
	 CALL NORM(S11) 
	 CALL NORM(S12)
C======================================================
C Calculate all twelve MJT matrices
	CALL MJTMATRIX(MJT1,H1,HT1,U1,S1)
	CALL MJTMATRIX(MJT2,H1,HT1,U2,S2)
	CALL MJTMATRIX(MJT3,H1,HT1,U3,S3)
	CALL MJTMATRIX(MJT4,H2,HT2,U4,S4)
	CALL MJTMATRIX(MJT5,H2,HT2,U5,S5)
	CALL MJTMATRIX(MJT6,H2,HT2,U6,S6)
	CALL MJTMATRIX(MJT7,H3,HT3,U7,S7)
	CALL MJTMATRIX(MJT8,H3,HT3,U8,S8)
	CALL MJTMATRIX(MJT9,H3,HT3,U9,S9)
	CALL MJTMATRIX(MJT10,H4,HT4,U10,S10)
	CALL MJTMATRIX(MJT11,H4,HT4,U11,S11)
	CALL MJTMATRIX(MJT12,H4,HT4,U12,S12)
C=======================================================
C Calculate all tewlve Schmid factors
	IF (SIG .EQ. 2) THEN
		CALL STRAINENERGY(SMF(1),TENSOR,H1,U1)
		CALL STRAINENERGY(SMF(2),TENSOR,H1,U2)
		CALL STRAINENERGY(SMF(3),TENSOR,H1,U3)
		CALL STRAINENERGY(SMF(4),TENSOR,H2,U4)
		CALL STRAINENERGY(SMF(5),TENSOR,H2,U5)
		CALL STRAINENERGY(SMF(6),TENSOR,H2,U6)
		CALL STRAINENERGY(SMF(7),TENSOR,H3,U7)
		CALL STRAINENERGY(SMF(8),TENSOR,H3,U8)
		CALL STRAINENERGY(SMF(9),TENSOR,H3,U9)
		CALL STRAINENERGY(SMF(10),TENSOR,H4,U10)
		CALL STRAINENERGY(SMF(11),TENSOR,H4,U11)
		CALL STRAINENERGY(SMF(12),TENSOR,H4,U12)
	
	ELSE
		CALL SCHMID(SMF(1),A,H1,U1,SIG)
		CALL SCHMID(SMF(2),A,H1,U2,SIG)
		CALL SCHMID(SMF(3),A,H1,U3,SIG)
		CALL SCHMID(SMF(4),A,H2,U4,SIG)
		CALL SCHMID(SMF(5),A,H2,U5,SIG)
		CALL SCHMID(SMF(6),A,H2,U6,SIG)
		CALL SCHMID(SMF(7),A,H3,U7,SIG)
		CALL SCHMID(SMF(8),A,H3,U8,SIG)
		CALL SCHMID(SMF(9),A,H3,U9,SIG)
		CALL SCHMID(SMF(10),A,H4,U10,SIG)
		CALL SCHMID(SMF(11),A,H4,U11,SIG)
		CALL SCHMID(SMF(12),A,H4,U12,SIG)
	ENDIF

C========================================================
C Make double dimension arrays for sorting data
C MJTA,HA,UA mean MJT array, H array, U array(They are needed in sorting)
	CALL MAKEARRAY(MJT1,H1,U1,MJTA,HA,UA,1)
	CALL MAKEARRAY(MJT2,H1,U2,MJTA,HA,UA,2)
	CALL MAKEARRAY(MJT3,H1,U3,MJTA,HA,UA,3)
	CALL MAKEARRAY(MJT4,H2,U4,MJTA,HA,UA,4)
	CALL MAKEARRAY(MJT5,H2,U5,MJTA,HA,UA,5)
	CALL MAKEARRAY(MJT6,H2,U6,MJTA,HA,UA,6)
	CALL MAKEARRAY(MJT7,H3,U7,MJTA,HA,UA,7)
	CALL MAKEARRAY(MJT8,H3,U8,MJTA,HA,UA,8)
	CALL MAKEARRAY(MJT9,H3,U9,MJTA,HA,UA,9)
	CALL MAKEARRAY(MJT10,H4,U10,MJTA,HA,UA,10)
	CALL MAKEARRAY(MJT11,H4,U11,MJTA,HA,UA,11)
	CALL MAKEARRAY(MJT12,H4,U12,MJTA,HA,UA,12)

	CALL SORT(MJTA,HA,UA,SMF)
C	CALL MULTRITE(MJTA,HA,UA,SMF,12)

	 RETURN
	 END
	 
C=======================================================================
C=======================================================================
C Subroutine to WRITE nicely
C writes the deformation matrix (F T F), twin plane (H:F*)
C  and the twin direction [F:U]
C
	SUBROUTINE RITE(T,H,U,SMF)
	DOUBLE PRECISION T(9),H(3),U(3),SMF
C
	WRITE(*,2) H(1),H(2),H(3),U(1),U(2),U(3),SMF,
     &	T(1),T(2),T(3),T(4),T(5),T(6),T(7),T(8),T(9) 

2	FORMAT(/ 2X,'the operating twinning system is:',
     &	     / 2X,'H=(', 3F7.4,')',2X,'U=[', 3F7.4,']', 2X, 'SMF=',F7.4
     &       / 2X,'|', 3F7.4,'|'/ 2X,'|',3F7.4,'|'/ 2X,'|',3F7.4,'|'/)
	RETURN
	END
C=======================================================================
C=======================================================================
C Subroutine to calculate Schmid factor
C 'SCHMID' means schmid factor
C 'A': tensile axis of local grain
C 'H,U': twinning plane normal and twinning direction
C
C INPUT PARAMETER: A,H,U
C OUTPUT PARAMETER: SMF
	SUBROUTINE SCHMID(SMF,A,H,U,SIG)
	DOUBLE PRECISION A(3),H(3),U(3),DOT1, DOT2, SMF
	INTEGER SIG
C
	CALL NORM(A)
		CALL NORM(H)
			CALL NORM(U)
	DOT1 = A(1)*H(1)+A(2)*H(2)+A(3)*H(3)
	DOT2 = A(1)*U(1)+A(2)*U(2)+A(3)*U(3)
C
	SMF = SIG*DOT1*DOT2

	RETURN
	END


C=======================================================================
C=======================================================================
	SUBROUTINE MAKEARRAY(MJT,H,U,MJTA,HA,UA,NUM)
        DOUBLE PRECISION MJT(9),H(3),U(3)
        DOUBLE PRECISION MJTA(12,9),HA(12,3),UA(12,3)
	INTEGER I,NUM

	 DO 3 I=1,9
          MJTA(NUM,I) = MJT(I)
          IF (I .LT. 4) THEN
	   HA(NUM,I) = H(I)
           UA(NUM,I) = U(I)
	  ENDIF
3        CONTINUE

        RETURN
	END

C=======================================================================
C=======================================================================
	SUBROUTINE SORT(MJTA,HA,UA,SMF)
        DOUBLE PRECISION MJTA(12,9),HA(12,3),UA(12,3),SMF(12)
	DOUBLE PRECISION TEMPt(9),TEMPh(3),TEMPu(3),TEMPsmf
        INTEGER I,J,K

C Using bubble sort algorithm
	DO 5 I=1,11
	 DO 6 J=12,I+1,-1
	  IF(SMF(J-1) .LE. SMF(J)) THEN

C This part is for replacement between data(J) and data(J-1)
	   TEMPsmf = SMF(J-1)
	   DO 7 K=1,9
	    TEMPt(K) = MJTA(J-1,K)
	    IF(K .LT. 4) THEN
             TEMPh(K) = HA(J-1,K)
	     TEMPu(K) = UA(J-1,K)
	    ENDIF
7          CONTINUE

	   SMF(J-1) = SMF(J)
	   DO 8 K=1,9
	    MJTA(J-1,K) = MJTA(J,K)
	    IF(K .LT. 4) THEN
             HA(J-1,K) = HA(J,K)
  	     UA(J-1,K) = UA(J,K)
	    ENDIF
8          CONTINUE

	   SMF(J) = TEMPsmf
	   DO 9 K=1,9
	    MJTA(J,K) = TEMPt(K)
	    IF(K .LT. 4) THEN
             HA(J,K) = TEMPh(K)
 	     UA(J,K) = TEMPu(K)
	    ENDIF
9          CONTINUE
           
          ENDIF

6        CONTINUE
5       CONTINUE

        RETURN
	END
C=======================================================================
C=======================================================================
C Subroutine to WRITE sorted array(12x*)
C writes the deformation matrix (F T F), twin plane (H:F*)
C  and the twin direction [F:U]
C
      SUBROUTINE MULTRITE(MJTA,HA,UA,SMF,RITE_NUM)
      DOUBLE PRECISION MJTA(12,9),HA(12,3),UA(12,3),SMF(12)
      INTEGER I,RITE_NUM
C
      DO 5 I=1,RITE_NUM
      WRITE(*,1) I
     &	,HA(I,1),HA(I,2),HA(I,3),UA(I,1),UA(I,2),UA(I,3),SMF(I)
     &	,MJTA(I,1),MJTA(I,2),MJTA(I,3),MJTA(I,4),MJTA(I,5)
     &	,MJTA(I,6),MJTA(I,7),MJTA(I,8),MJTA(I,9) 

5     CONTINUE

1	FORMAT(/ 2X,'the operating twinning system',I2,' is: '
     &	/ 2X,'H=(', 3F8.4,')',2X,'U=[', 3F8.4,']', 2X, 'SMF=',F8.4,
     &	/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')	
      RETURN
      END

C=======================================================================
C=======================================================================
C
C **** Generating the random number to get rotation axis and angle *****
C        
	SUBROUTINE ROT_RAND(R,A,TED)
	DOUBLE PRECISION R(9),A(3),TED(3)
	DOUBLE PRECISION THETA,THETATEMP,TEMP(3)
	INTEGER I
C
         I=1
         DO 90 WHILE(I .LE. 3)
            THETA=RAND()
	    THETATEMP=0.5*THETA-0.25
            IF(I .NE. 2) THEN
               TEMP(I)=2*3.1415926*THETATEMP
            ELSE
              TEMP(I)=2*THETA-1.0D+00
            END IF 
            I=I+1
   90    CONTINUE
C
C **********************************************************************
C
C ********************** Generating the rotational matrix **************
C
C           |R(1) R(2) R(3)|
C (M2 J M1)=|R(4) R(5) R(6)|. Tensile direction in grain 2 equals 
C           |R(7) R(8) R(9)|
C
C [M2;A]=(M2 J M1)[M1;TED]
C
         R(1) = COS(TEMP(1))*COS(TEMP(3))-SIN(TEMP(1))
     &                            *TEMP(2)*SIN(TEMP(3))        
         R(2) = SIN(TEMP(1))*COS(TEMP(3))+COS(TEMP(1))
     &                            *TEMP(2)*SIN(TEMP(3)) 
         R(3) = dsqrt(1-TEMP(2)**2)*SIN(TEMP(3))
C       
         R(4) = -COS(TEMP(1))*SIN(TEMP(3))-SIN(TEMP(1))
     &                            *TEMP(2)*COS(TEMP(3))
         R(5) = -SIN(TEMP(1))*SIN(TEMP(3))+COS(TEMP(1))
     &                            *TEMP(2)*COS(TEMP(3))
         R(6) = dsqrt(1-TEMP(2)**2)*COS(TEMP(3))
C        
         R(7) = SIN(TEMP(1))*dsqrt(1-TEMP(2)**2)
         R(8) = -COS(TEMP(1))*dsqrt(1-TEMP(2)**2)
         R(9) = TEMP(2)
C
	A(1)=R(1)*TED(1)+R(2)*TED(2)+R(3)*TED(3)
	A(2)=R(4)*TED(1)+R(5)*TED(2)+R(6)*TED(3)
	A(3)=R(7)*TED(1)+R(8)*TED(2)+R(9)*TED(3)
C
C	WRITE(*,40) A(1),A(2),A(3)
C40	FORMAT (/2X,'Tensile axis in local grain is:',2X,'[', 3F8.4,']')
C
	RETURN
	END


C=======================================================================
C=======================================================================
C generate coordinate matrix (M1 J M2) describing relationship
C between crystal 1 and crystal 2

	SUBROUTINE ROT_TEXTURED(R,A,TED,ROT_ANGLE)
C argument declaration
C 'P1,P2,P3,THETA': randomly generated four numbers to form (M1 J M2)
C 'A': components of tensile axis, with respect to the local grain
C 'R': components of coordinate matrix (M1 J M2)
C 	    |R(1) R(2) R(3)|
C (M2 J M1)=|R(4) R(5) R(6)|
C 	    |R(7) R(8) R(9)|
C 'TED': components of tensile axis, with respect to the first grain

C INPUT PARAMETER: TED(3)
C OUTPUT PARAMETER: R(9),A(3)

	DOUBLE PRECISION P1,P2,P3,P,THETA,A5,A(3),TED(3)
	DOUBLE PRECISION R(9)
	DOUBLE PRECISION ROT_ANGLE,ROT_ANGLE_REF

C generate three random values
	P1=2*RAND()-1
	P2=2*RAND()-1
	P3=2*RAND()-1
	P=DSQRT(P1*P1+P2*P2+P3*P3)
	P1=P1/P
	P2=P2/P
	P3=P3/P
	ROT_ANGLE_REF = 45.00
	THETA=3.14159*(0.5*RAND()-0.25) * ROT_ANGLE/ROT_ANGLE_REF

C calculate nine components of  (M1 J M2)
	A5=1.0
	R(1)=P1*P1*(A5-COS(THETA))+COS(THETA)
	R(2)=P2*P1*(A5-COS(THETA))+P3*SIN(THETA)
	R(3)=P3*P1*(A5-COS(THETA))-P2*SIN(THETA)
	R(4)=P1*P2*(A5-COS(THETA))-P3*SIN(THETA)
	R(5)=P2*P2*(A5-COS(THETA))+COS(THETA)
	R(6)=P2*P3*(A5-COS(THETA))+P1*SIN(THETA)
	R(7)=P1*P3*(A5-COS(THETA))+P2*SIN(THETA)
	R(8)=P2*P3*(A5-COS(THETA))-P1*SIN(THETA)
	R(9)=P3*P3*(A5-COS(THETA))+COS(THETA)
C	WRITE(*,30) R(1),R(2),R(3),R(4),R(5),R(6),R(7),R(8),R(9)
C30	FORMAT (/2X, 'Coordinate transformation matrix (M2 J M1) is: '
C&		/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')

C Convert components of tensile axis into the components with respect to grain 2
	A(1)=R(1)*TED(1)+R(2)*TED(2)+R(3)*TED(3)
	A(2)=R(4)*TED(1)+R(5)*TED(2)+R(6)*TED(3)
	A(3)=R(7)*TED(1)+R(8)*TED(2)+R(9)*TED(3)
C
C	WRITE(*,40) A(1),A(2),A(3)
C40	FORMAT (/2X,'Tensile axis in local grain is:',2X,'[', 3F8.4,']')
C
	RETURN
	END

C=======================================================================
C=======================================================================
C Subroutine to maintain the the original tensile axis for the first grain

	SUBROUTINE ROT_ORI(R,A,TED)
C argument declaration
C 'A': components of tensile axis, with respect to the local grain
C 'R': components of coordinate matrix (M1 J M2)
C 'TED': components of tensile axis, with respect to the first grain

C INPUT PARAMETER: TED(9)
C OUTPUT PARAMETER: R(9), A(3)

	DOUBLE PRECISION R(9),A(3),TED(9)
	DOUBLE PRECISION P(3,3),PTRANS(3,3)
	INTEGER J
	
	R(1)=1.0D+00
	R(2)=0.0D+00
	R(3)=0.0D+00
	R(4)=0.0D+00
	R(5)=1.0D+00
	R(6)=0.0D+00
	R(7)=0.0D+00
	R(8)=0.0D+00
	R(9)=1.0D+00
	A(1)=R(1)*TED(1)+R(2)*TED(2)+R(3)*TED(3)
	A(2)=R(4)*TED(1)+R(5)*TED(2)+R(6)*TED(3)
	A(3)=R(7)*TED(1)+R(8)*TED(2)+R(9)*TED(3)
C	WRITE(*,10) R(1),R(2),R(3),R(4),R(5),R(6),R(7),R(8),R(9)
C10	FORMAT (/2X, 'Coordinate transformation matrix (M2 J M1) is: '
C&		/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')
	RETURN
	END

C==========================================================================================
C==========================================================================================
C Subroutine to find out the poles of twin in grain 2
C------------------------------------------------------------------------------------------
C       =	(SJG)	       *        (M1 J M2)        *        (MJT)         * |POLE|
C |V(1)| |SJG(1) SJG(2) SJG(3)| |RINV(1) RINV(2) RINV(3)| |MJT(1) MJT(2) MJT(3)| |POLE(1)|
C |V(2)|=|SJG(4) SJG(5) SJG(6)|*|RINV(4) RINV(5) RINV(6)|*|MJT(4) MJT(5) MJT(6)|*|POLE(2)|
C |V(3)| |SJG(7) SJG(8) SJG(9)| |RINV(7) RINV(8) RINV(9)| |MJT(7) MJT(8) MJT(9)| |POLE(3)|
C------------------------------------------------------------------------------------------
C	 |SJG(1) SJG(2) SJG(3)| |TEMPRINV(1) TEMPRINV(2) TEMPRINV(3)| |POLE(1)| 
C	=|SJG(4) SJG(5) SJG(6)|*|TEMPRINV(4) TEMPRINV(5) TEMPRINV(6)|*|POLE(2)|
C	 |SJG(7) SJG(8) SJG(9)| |TEMPRINV(7) TEMPRINV(8) TEMPRINV(9)| |POLE(3)|
C------------------------------------------------------------------------------------------
C        |SJGGT2(1) SJGGT2(2) SJGGT2(3)| |POLE(1)| 
C       =|SJGGT2(4) SJGGT2(5) SJGGT2(6)|*|POLE(2)|
C        |SJGGT2(7) SJGGT2(8) SJGGT2(9)| |POLE(3)|
C------------------------------------------------------------------------------------------
C 'SJGGT2': Components of SJG of grain 2
C 'TPOG2': Twin Poles of Grain 2
C 'XOG2T': X of Grain 2, Twin
C 'YOG2T': Y of Grain 2, Twin

C INPUT PARAMETERS: POLE, SJG
C OUTPUT PARAMETERS: XOG2T,YOG2T,XOG2T,YOG2T

      SUBROUTINE TPOG2(MJTA,POLE,R,SJG,XOG2T,YOG2T)
C Augument Declarations:
      DOUBLE PRECISION MJTA(12,9),A(3),POLE(3),R(9),XOG2T(12),YOG2T(12)
C Local Declarations:
      DOUBLE PRECISION SJG(9),SJGGT2(9),TEMPRINV(9),V(3),RINV(9),XTT,YTT
      INTEGER I
      DOUBLE PRECISION DETER,DETESJG,DETESJGGT2
      CHARACTER *10 TWIN

C CALL INVERSE to get the inverse of (M2 J M1), which is (M1 J M2)
	CALL INVERSE(R,RINV)
C SJG, which are the components of the matrix 
C which converts vector from grain reference to sample reference are known
      DO 10 I = 1,12
      TEMPRINV(1)=RINV(1)*MJTA(I,1)+RINV(2)*MJTA(I,4)+RINV(3)*MJTA(I,7)
      TEMPRINV(2)=RINV(1)*MJTA(I,2)+RINV(2)*MJTA(I,5)+RINV(3)*MJTA(I,8)
      TEMPRINV(3)=RINV(1)*MJTA(I,3)+RINV(2)*MJTA(I,6)+RINV(3)*MJTA(I,9)
      TEMPRINV(4)=RINV(4)*MJTA(I,1)+RINV(5)*MJTA(I,4)+RINV(6)*MJTA(I,7)
      TEMPRINV(5)=RINV(4)*MJTA(I,2)+RINV(5)*MJTA(I,5)+RINV(6)*MJTA(I,8)
      TEMPRINV(6)=RINV(4)*MJTA(I,3)+RINV(5)*MJTA(I,6)+RINV(6)*MJTA(I,9)
      TEMPRINV(7)=RINV(7)*MJTA(I,1)+RINV(8)*MJTA(I,4)+RINV(9)*MJTA(I,7)
      TEMPRINV(8)=RINV(7)*MJTA(I,2)+RINV(8)*MJTA(I,5)+RINV(9)*MJTA(I,8)
      TEMPRINV(9)=RINV(7)*MJTA(I,3)+RINV(8)*MJTA(I,6)+RINV(9)*MJTA(I,9)

C
      SJGGT2(1)=SJG(1)*TEMPRINV(1)+SJG(2)*TEMPRINV(4)+SJG(3)*TEMPRINV(7)
      SJGGT2(2)=SJG(1)*TEMPRINV(2)+SJG(2)*TEMPRINV(5)+SJG(3)*TEMPRINV(8)
      SJGGT2(3)=SJG(1)*TEMPRINV(3)+SJG(2)*TEMPRINV(6)+SJG(3)*TEMPRINV(9)
      SJGGT2(4)=SJG(4)*TEMPRINV(1)+SJG(5)*TEMPRINV(4)+SJG(6)*TEMPRINV(7)
      SJGGT2(5)=SJG(4)*TEMPRINV(2)+SJG(5)*TEMPRINV(5)+SJG(6)*TEMPRINV(8)
      SJGGT2(6)=SJG(4)*TEMPRINV(3)+SJG(5)*TEMPRINV(6)+SJG(6)*TEMPRINV(9)
      SJGGT2(7)=SJG(7)*TEMPRINV(1)+SJG(8)*TEMPRINV(4)+SJG(9)*TEMPRINV(7)
      SJGGT2(8)=SJG(7)*TEMPRINV(2)+SJG(8)*TEMPRINV(5)+SJG(9)*TEMPRINV(8)
      SJGGT2(9)=SJG(7)*TEMPRINV(3)+SJG(8)*TEMPRINV(6)+SJG(9)*TEMPRINV(9)
C
      V(1)=SJGGT2(1)*POLE(1)+SJGGT2(2)*POLE(2)+SJGGT2(3)*POLE(3)
      V(2)=SJGGT2(4)*POLE(1)+SJGGT2(5)*POLE(2)+SJGGT2(6)*POLE(3)
      V(3)=SJGGT2(7)*POLE(1)+SJGGT2(8)*POLE(2)+SJGGT2(9)*POLE(3)
	
C	CALL DETERMINANT(SJGGT2,DETER)

C------------------------------------------------------------------
C check whether there are mistakes in the calculation
C	WRITE(*,21) R(1),R(2),R(3),R(4),R(5),R(6),R(7),R(8),R(9)
C21	FORMAT (/2X, 'R(9) is: '
C&		/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')
C	CALL DETERMINANT(R,DETER)
C
C	WRITE(*,22) SJG(1),SJG(2),SJG(3),SJG(4),SJG(5),SJG(6),SJG(7),
C    &		    SJG(8),SJG(9)
C22	FORMAT (/2X, 'SJG(9) is: '
C&		/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')
C	CALL DETERMINANT(SJG,DETESJG)
C
C C
C	WRITE(*,23) SJGGT2(1),SJGGT2(2),SJGGT2(3),SJGGT2(4),SJGGT2(5),
C    &		    SJGGT2(6),SJGGT2(7),SJGGT2(8),SJGGT2(9)
C23	FORMAT (/2X, 'SJGGT(9) is: '
C&		/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')
C	CALL DETERMINANT(SJGGT2,DETESJGGT2)
C-------------------------------------------------------------------

		IF (I .EQ. 1) THEN
			TWIN='twin(1)'
		ELSEIF (I .EQ. 2) THEN
			TWIN='twin(2)'
		ELSEIF (I .EQ. 3) THEN
			TWIN='twin(3)'
		ELSEIF (I .EQ. 4) THEN
			TWIN='twin(4)'
		ELSEIF (I .EQ. 5) THEN
			TWIN='twin(5)'
		ELSEIF (I .EQ. 6) THEN
			TWIN='twin(6)'
		ELSEIF (I .EQ. 7) THEN
			TWIN='twin(7)'
		ELSEIF (I .EQ. 8) THEN
			TWIN='twin(8)'
		ELSEIF (I .EQ. 9) THEN
			TWIN='twin(9)'
		ELSEIF (I .EQ. 10) THEN
			TWIN='twin(10)'
		ELSEIF (I .EQ. 11) THEN
			TWIN='twin(11)'
		ELSE
			TWIN='twin(12)'
		ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC	
C	CALL SJGVECTOR(SJGGT2,POLE,V)
	CALL TDTTD(TWIN,V,XTT,YTT)
C 'XTT, YTT' means X temporary

	XOG2T(I)=XTT
	YOG2T(I)=YTT	
C
10	CONTINUE
	
	RETURN
	END

C=======================================================================
C=======================================================================
C Subroutine to find out the poles of Matrix in grain 2
C-----------------------------------------------------------------------
C       =	(SJG)	       *         (M1 J M2)       * |POLE|
C |V(1)| |SJG(1) SJG(2) SJG(3)| |RINV(1) RINV(2) RINV(3)| |POLE(1)|
C |V(2)|=|SJG(4) SJG(5) SJG(6)|*|RINV(4) RINV(5) RINV(6)|*|POLE(2)|
C |V(3)| |SJG(7) SJG(8) SJG(9)| |RINV(7) RINV(8) RINV(9)| |POLE(3)|
C-----------------------------------------------------------------------
C        |SJGGM2(1) SJGGM2(2) SJGGM2(3)| |POLE(1)|
C       =|SJGGM2(4) SJGGM2(5) SJGGM2(6)|*|POLE(2)|
C        |SJGGM2(7) SJGGM2(8) SJGGM2(9)| |POLE(3)|
C-----------------------------------------------------------------------
C 'MPOG2' stands for Matrix poles of grain 2
C 'XOG2M' stands for X of Grain 2 Matrix
C 'YOG2M' stands for Y of Grain 2 Matrix
C
C INPUT: POLE,R(9)
C OUTPUT: XOG2M,YOG2M
C
	SUBROUTINE MPOG2(A,POLE,R,SJG,XOG2M,YOG2M)
C Argument Declaration
	DOUBLE PRECISION A(3),POLE(3),R(9),XOG2M,YOG2M
C Local Declaration
	DOUBLE PRECISION SJGGM2(9),SJG(9),RINV(9),V(3),XMT,YMT
	DOUBLE PRECISION DETER,DETESJG,DETESJGGM2
	CHARACTER *10 MATRIX
C
	CALL INVERSE(R,RINV)
	SJGGM2(1)=SJG(1)*RINV(1)+SJG(2)*RINV(4)+SJG(3)*RINV(7)
	SJGGM2(2)=SJG(1)*RINV(2)+SJG(2)*RINV(5)+SJG(3)*RINV(8)
	SJGGM2(3)=SJG(1)*RINV(3)+SJG(2)*RINV(6)+SJG(3)*RINV(9)
	SJGGM2(4)=SJG(4)*RINV(1)+SJG(5)*RINV(4)+SJG(6)*RINV(7)
	SJGGM2(5)=SJG(4)*RINV(2)+SJG(5)*RINV(5)+SJG(6)*RINV(8)
	SJGGM2(6)=SJG(4)*RINV(3)+SJG(5)*RINV(6)+SJG(6)*RINV(9)
	SJGGM2(7)=SJG(7)*RINV(1)+SJG(8)*RINV(4)+SJG(9)*RINV(7)
	SJGGM2(8)=SJG(7)*RINV(2)+SJG(8)*RINV(5)+SJG(9)*RINV(8)
	SJGGM2(9)=SJG(7)*RINV(3)+SJG(8)*RINV(6)+SJG(9)*RINV(9)
C
	V(1)=SJGGM2(1)*POLE(1)+SJGGM2(2)*POLE(2)+SJGGM2(3)*POLE(3)
	V(2)=SJGGM2(4)*POLE(1)+SJGGM2(5)*POLE(2)+SJGGM2(6)*POLE(3)
	V(3)=SJGGM2(7)*POLE(1)+SJGGM2(8)*POLE(2)+SJGGM2(9)*POLE(3)
C------------------------------------------------------------------
C check whether there are mistakes in the calculation
C
C	WRITE(*,21) R(1),R(2),R(3),R(4),R(5),R(6),R(7),R(8),R(9)
C21	FORMAT (/2X, 'R(9) is: '
C    &		/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')
C	CALL DETERMINANT(R,DETER)
C C
C	WRITE(*,22) SJG(1),SJG(2),SJG(3),SJG(4),SJG(5),SJG(6),SJG(7),
C    &		    SJG(8),SJG(9)
C22	FORMAT (/2X, 'SJG(9) is: '
C&		/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')
C	CALL DETERMINANT(SJG,DETESJG)
C
C C
C	WRITE(*,23) SJGGM2(1),SJGGM2(2),SJGGM2(3),SJGGM2(4),SJGGM2(5),
C    &		    SJGGM2(6),SJGGM2(7),SJGGM2(8),SJGGM2(9)
C23	FORMAT (/2X, 'SJGGM2(9) is: '
C    &		/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')
C	CALL DETERMINANT(SJGGM2,DETESJGGM2)
C-------------------------------------------------------------------
C	CALL SJGVECTOR(SJGGM2,POLE,V)
		MATRIX='matrix'
	CALL TDTTD(MATRIX,V,XMT,YMT)
C 'XT, YT' means X temporary

	XOG2M=XMT
	YOG2M=YMT	
C	
	RETURN
	END

C=======================================================================
C	SUBROUTINE TO FIND OUT THE PTRANS(3,3) USING R(9)
	SUBROUTINE FIND_PTRANS(R,PTRANS,SJG)
	DOUBLE PRECISION R(9),PTRANS(3,3),SJG(9)
	DOUBLE PRECISION LENGTHPTRANS
	INTEGER J
	DOUBLE PRECISION P1_IN_S(3),P2_IN_S(3),P3_IN_S(3),P(3,3)
	DOUBLE PRECISION P1_IN_G1(3),P2_IN_G1(3),P3_IN_G1(3)
	DOUBLE PRECISION G1JS(9)

	P1_IN_S(1)=1
	P1_IN_S(2)=0
	P1_IN_S(3)=0
	
	P2_IN_S(1)=0
	P2_IN_S(2)=1
	P2_IN_S(3)=0
	
	P3_IN_S(1)=0
	P3_IN_S(2)=0
	P3_IN_S(3)=1
	
	CALL INVERSE(SJG,G1JS)
C	[G1;100]; [G1;010]; [G1;001]
	CALL MATRIX_VECTOR(G1JS,P1_IN_S,P1_IN_G1)
	CALL MATRIX_VECTOR(G1JS,P2_IN_S,P2_IN_G1)
	CALL MATRIX_VECTOR(G1JS,P3_IN_S,P3_IN_G1)
	
	P(1,1)=P1_IN_G1(1)
	P(2,1)=P1_IN_G1(2)
	P(3,1)=P1_IN_G1(3)
C
	P(1,2)=P2_IN_G1(1)
	P(2,2)=P2_IN_G1(2)
	P(3,2)=P2_IN_G1(3)
C
	P(1,3)=P3_IN_G1(1)
	P(2,3)=P3_IN_G1(2)
	P(3,3)=P3_IN_G1(3)
	
C Calculate three column vectors
	DO 10 J = 1,3
	PTRANS(1,J)=R(1)*P(1,J)+R(2)*P(2,J)+R(3)*P(3,J)
	PTRANS(2,J)=R(4)*P(1,J)+R(5)*P(2,J)+R(6)*P(3,J)
	PTRANS(3,J)=R(7)*P(1,J)+R(8)*P(2,J)+R(9)*P(3,J)
C
	LENGTHPTRANS=DSQRT(PTRANS(1,J)*PTRANS(1,J)+
     &	PTRANS(2,J)*PTRANS(2,J)+PTRANS(3,J)*PTRANS(3,J))
C
C	WRITE(*,20) PTRANS(1,J),PTRANS(2,J),PTRANS(3,J),LENGTHPTRANS
C20	FORMAT (2X,'[100]//[',3F8.4,'], Length is',F8.4)
10	CONTINUE
C
	RETURN
	END

	
C=======================================================================
C=======================================================================
C Subroutine to define all the twinning matrices
C
      SUBROUTINE TWIN(TA,A,TENSOR,SIG)
C	
	 DOUBLE PRECISION T1(9),T2(9),T3(9),T4(9),T5(9),T6(9),
     &	   T7(9),T8(9),T9(9),T10(9),T11(9),T12(9) 
	 DOUBLE PRECISION H1(3),H2(3),H3(3),H4(3),
     &   	U1(3),U2(3),U3(3),U4(3),U5(3),U6(3),U7(3),
     &   	U8(3),U9(3),U10(3),U11(3),U12(3),SMF(12),
     &          A(3)
         DOUBLE PRECISION TA(12,9),HA(12,3),UA(12,3)
         INTEGER I,MAXCOUNT,SIG
         DOUBLE PRECISION TENSOR(9)
C Define twin planes	
	 H1(1)=1
	 H1(2)=1
	 H1(3)=1
C
	 H2(1)=1
	 H2(2)=-1
	 H2(3)=-1
C  
	 H3(1)=-1
	 H3(2)=1
	 H3(3)=-1
C
	 H4(1)=-1
	 H4(2)=-1
	 H4(3)=1
C
C Define twin directions in (111)
C	 
	 U1(1)=1
	 U1(2)=1
	 U1(3)=-2
C	 
	 U2(1)=1
	 U2(2)=-2
	 U2(3)=1
C	 
	 U3(1)=-2
	 U3(2)=1
	 U3(3)=1
C	Define twin directions in (1-1-1) 
C	 
	 U4(1)=1
	 U4(2)=2
	 U4(3)=-1
C	 
	 U5(1)=1
	 U5(2)=-1
	 U5(3)=2
C	 
	 U6(1)=-2
	 U6(2)=-1
	 U6(3)=-1
C	Define twin directions in (-11-1) 
C	 
	 U7(1)=-1
	 U7(2)=-2
	 U7(3)=-1
C	 
	 U8(1)=-1
	 U8(2)=1
	 U8(3)=2
C	 
	 U9(1)=2
	 U9(2)=1
	 U9(3)=-1
C
C	Define twin directions in (-1-11) 
	 U10(1)=-1
	 U10(2)=-1
	 U10(3)=-2
C	 
	 U11(1)=-1
	 U11(2)=2
	 U11(3)=1
C	 
	 U12(1)=2
	 U12(2)=-1
	 U12(3)=1
C
C Normalise everything to unit vectors
	 CALL NORM(H1)
	 CALL NORM(H2)
	 CALL NORM(H3)
	 CALL NORM(H4)
	 	 	 	 
	 CALL NORM(U1) 	 	
	 CALL NORM(U2) 
	 CALL NORM(U3) 	
	 	 	 	 
	 CALL NORM(U4) 	 	
	 CALL NORM(U5) 
	 CALL NORM(U6) 	 	 	 
	 	 	 	 
	 CALL NORM(U7) 	 	
	 CALL NORM(U8) 
	 CALL NORM(U9) 
	 	 	 	 
	 CALL NORM(U10) 	 	
	 CALL NORM(U11) 
	 CALL NORM(U12) 	 
C
C Calculate the twelve deformation matrices (F T F)
	 	 	 
	 CALL DEFORM(T1,H1,U1)
	 CALL DEFORM(T2,H1,U2)
	 CALL DEFORM(T3,H1,U3)
	 CALL DEFORM(T4,H2,U4)
	 CALL DEFORM(T5,H2,U5)
	 CALL DEFORM(T6,H2,U6)	 
	 CALL DEFORM(T7,H3,U7)
	 CALL DEFORM(T8,H3,U8)
	 CALL DEFORM(T9,H3,U9)
	 CALL DEFORM(T10,H4,U10)
	 CALL DEFORM(T11,H4,U11)
	 CALL DEFORM(T12,H4,U12)	
C
C Calculate the schmid factors
	IF (SIG .EQ. 2) THEN
		CALL STRAINENERGY(SMF(1),TENSOR,H1,U1)
		CALL STRAINENERGY(SMF(2),TENSOR,H1,U2)
		CALL STRAINENERGY(SMF(3),TENSOR,H1,U3)
		CALL STRAINENERGY(SMF(4),TENSOR,H2,U4)
		CALL STRAINENERGY(SMF(5),TENSOR,H2,U5)
		CALL STRAINENERGY(SMF(6),TENSOR,H2,U6)
		CALL STRAINENERGY(SMF(7),TENSOR,H3,U7)
		CALL STRAINENERGY(SMF(8),TENSOR,H3,U8)
		CALL STRAINENERGY(SMF(9),TENSOR,H3,U9)
		CALL STRAINENERGY(SMF(10),TENSOR,H4,U10)
		CALL STRAINENERGY(SMF(11),TENSOR,H4,U11)
		CALL STRAINENERGY(SMF(12),TENSOR,H4,U12)
	
	ELSE
		CALL SCHMID(SMF(1),A,H1,U1,SIG)
		CALL SCHMID(SMF(2),A,H1,U2,SIG)
		CALL SCHMID(SMF(3),A,H1,U3,SIG)
		CALL SCHMID(SMF(4),A,H2,U4,SIG)
		CALL SCHMID(SMF(5),A,H2,U5,SIG)
		CALL SCHMID(SMF(6),A,H2,U6,SIG)
		CALL SCHMID(SMF(7),A,H3,U7,SIG)
		CALL SCHMID(SMF(8),A,H3,U8,SIG)
		CALL SCHMID(SMF(9),A,H3,U9,SIG)
		CALL SCHMID(SMF(10),A,H4,U10,SIG)
		CALL SCHMID(SMF(11),A,H4,U11,SIG)
		CALL SCHMID(SMF(12),A,H4,U12,SIG)
	ENDIF

C Make double dimension arrays for sorting data
C TA,HA,UA mean T array, H array, U array(They are needed in sorting)
	CALL MAKEARRAY(T1,H1,U1,TA,HA,UA,1)
	CALL MAKEARRAY(T2,H1,U2,TA,HA,UA,2)
	CALL MAKEARRAY(T3,H1,U3,TA,HA,UA,3)
	CALL MAKEARRAY(T4,H2,U4,TA,HA,UA,4)
	CALL MAKEARRAY(T5,H2,U5,TA,HA,UA,5)
	CALL MAKEARRAY(T6,H2,U6,TA,HA,UA,6)
	CALL MAKEARRAY(T7,H3,U7,TA,HA,UA,7)
	CALL MAKEARRAY(T8,H3,U8,TA,HA,UA,8)
	CALL MAKEARRAY(T9,H3,U9,TA,HA,UA,9)
	CALL MAKEARRAY(T10,H4,U10,TA,HA,UA,10)
	CALL MAKEARRAY(T11,H4,U11,TA,HA,UA,11)
	CALL MAKEARRAY(T12,H4,U12,TA,HA,UA,12)

	CALL SORT(TA,HA,UA,SMF)
C	CALL MULTRITE(TA,HA,UA,SMF,12)


	 RETURN
	 END
C=======================================================================
C=======================================================================
C
C Calculation of the components of distorted vector in a single grain
C  
C 'A' represents tensile axis in the austenite basis
C 'B' is the vector (F T F)[F;A]
C 'T' represents the deformation matrix (F T F)
C 'F' represents the components of distorted vector, with respect to the local coordinate
C 'FCOV' represents the components of distorted vector, with respect to coordinate of first grain
C
C [M2;V]=(M2 P M2)*(M2 J M1)*[M1;U];  [M1;U]=[100]
C

	SUBROUTINE FCOVRT(TA,R_INV,FCOV,VOL,PTRANS,NO_VIR,VOL_T,SJG)
C argument declaration
C P1: [100]
	DOUBLE PRECISION TA(12,9),R_INV(9),FCOV(3,3),VOL(12),
     &			 PTRANS(3,3),VOL_T,SJG(9)
     
C local declaration
	DOUBLE PRECISION C(12,3),F(3),LENGTHFCOV,LENGTHACOV
	INTEGER I,J,NO_VIR,K
	DOUBLE PRECISION FCOV_TEMP_1(3),FCOV_TEMP_2(3)
C calculate the components of the distorted vector in the first twin variant

C
	DO 10 I = 1,3
C
	F(1)=(1.0D+00-VOL_T)*PTRANS(1,I)
	F(2)=(1.0D+00-VOL_T)*PTRANS(2,I)
	F(3)=(1.0D+00-VOL_T)*PTRANS(3,I)
C
	DO 30 J = 1,NO_VIR
C calculate the components of the distorted vector in the first twin variant
      C(J,1)=TA(J,1)*PTRANS(1,I)+TA(J,2)*PTRANS(2,I)+TA(J,3)*PTRANS(3,I)
      C(J,2)=TA(J,4)*PTRANS(1,I)+TA(J,5)*PTRANS(2,I)+TA(J,6)*PTRANS(3,I)
      C(J,3)=TA(J,7)*PTRANS(1,I)+TA(J,8)*PTRANS(2,I)+TA(J,9)*PTRANS(3,I)

C calculate the components of the final distorted vector in the whole grain
	F(1)=F(1)+VOL(J)*C(J,1)
	F(2)=F(2)+VOL(J)*C(J,2)
	F(3)=F(3)+VOL(J)*C(J,3)
30	CONTINUE
C Convert F(1) F(2) F(3) into new components with respect to the basis of grain1
C 'FCOV' sTAnds for the new somponent
	FCOV(1,I)=R_INV(1)*F(1)+R_INV(2)*F(2)+R_INV(3)*F(3)
	FCOV(2,I)=R_INV(4)*F(1)+R_INV(5)*F(2)+R_INV(6)*F(3)
	FCOV(3,I)=R_INV(7)*F(1)+R_INV(8)*F(2)+R_INV(9)*F(3)
C
	FCOV_TEMP_1(1)=FCOV(1,I)
	FCOV_TEMP_1(2)=FCOV(2,I)
	FCOV_TEMP_1(3)=FCOV(3,I)
C
	CALL MATRIX_VECTOR(SJG,FCOV_TEMP_1,FCOV_TEMP_2)
C	
	FCOV(1,I)=FCOV_TEMP_2(1)
	FCOV(2,I)=FCOV_TEMP_2(2)
	FCOV(3,I)=FCOV_TEMP_2(3)
C		
	LENGTHFCOV=DSQRT(FCOV(1,I)*FCOV(1,I)+FCOV(2,I)*FCOV(2,I)
     &			    +FCOV(3,I)*FCOV(3,I))
C
C	WRITE(*,20) FCOV(1,I),FCOV(2,I),FCOV(3,I),LENGTHFCOV
C20	FORMAT (2X,'<100> ==> (FCOV): ',3F8.4,'], Length is',F8.4)
C
10	CONTINUE
C
	RETURN
	END
C=======================================================================
C=======================================================================
C Subroutine to add up all the converted FCOV
C 'FFIN' stands for the components of the distorted vector for all NG grains
	SUBROUTINE FFINAL(FFIN,FCOV)
	DOUBLE PRECISION FFIN(3,3),FCOV(3,3)
	INTEGER I,J
C	
	DO 10 J = 1,3
		FFIN(1,J)=FFIN(1,J)+FCOV(1,J)
		FFIN(2,J)=FFIN(2,J)+FCOV(2,J)
		FFIN(3,J)=FFIN(3,J)+FCOV(3,J)
10	CONTINUE
C
	RETURN
	END
C=======================================================================
C=======================================================================
C Subroutine to calculate the strain
C 'ELONG_NEW' represents the strain
C 'MAGA' is the magnitude of 'A'
C 'MAGB' is the magnitude of 'B'
C 'FFIN' represents the components of final distorted vector
C   with respect to the first grain
	SUBROUTINE STRAIN(FFIN,I,ELONG_NEW)
	DOUBLE PRECISION FFIN(3,3),MAGF,MAGA,ELONG_NEW(3)
	INTEGER I,J
	DO 10 J = 1,3
	MAGF=DSQRT(FFIN(1,J)*FFIN(1,J)+FFIN(2,J)*FFIN(2,J)
     &	+FFIN(3,J)*FFIN(3,J))
	MAGA=I*1.0D+00
	ELONG_NEW(J) = LOG(MAGF/MAGA)

C	WRITE(*,4) FFIN(1,J),FFIN(2,J),FFIN(3,J),MAGF,MAGA
C4	FORMAT('--------------------------------------------------'/
C     &		'net P:', '[',3F12.4,']',' MAGF=',F12.4,' MAG
C     &A=',F12.4)	
C	WRITE (*,5) ELONG_NEW(J)
C5	FORMAT('the total elongation for the polycrystal is:', F8.4)
10	CONTINUE
C
	RETURN
	END
C=======================================================================
C=======================================================================
C Subroutine to calculate deformation matrix (F T F)
	   SUBROUTINE DEFORM(T,H,U)
C Reference: Geometry of Crystals, Worked Examples, Bhadeshia,
C  2nd edition, page ****, equation ****
C
	   DOUBLE PRECISION T(9),H(3),U(3),M
C M is the twinning shear
	   M=1.0D+00/DSQRT(2.0D+00)
C
	   T(1)=1.0D+00+M*U(1)*H(1)
	   T(2)=M*U(1)*H(2)
	   T(3)=M*U(1)*H(3)
C
	   T(4)=M*U(2)*H(1)
	   T(5)=1.0D+00+M*U(2)*H(2)
	   T(6)=M*U(2)*H(3)
C
	   T(7)=M*U(3)*H(1)
	   T(8)=M*U(3)*H(2)
	   T(9)=1.0D+00+M*U(3)*H(3)	   	   	   
	   RETURN
	   END

C=======================================================================
C=======================================================================
	SUBROUTINE DETERMINANT(R,DETR)
	DOUBLE PRECISION R(9),DETR
	DETR=R(1)*R(5)*R(9)+R(2)*R(6)*R(7)+R(3)*R(4)*R(8)
     &	    -R(1)*R(6)*R(8)-R(2)*R(4)*R(9)-R(3)*R(5)*R(7)
	WRITE (*,1) DETR
1	FORMAT (2X,'DETERMINANT OF MATRIX is ', F8.4)
	RETURN
	END

C=======================================================================
C=======================================================================
	SUBROUTINE RITEPOLE(POLE)
	DOUBLE PRECISION POLE(3)
	WRITE(*,1) POLE(1),POLE(2),POLE(3)
1	FORMAT (/'~~~~~~~~~~~~~FOR [',3F8.4,']~~~~~~~~~~~~')
	RETURN
	END

C=======================================================================
C=======================================================================
	SUBROUTINE CALEULERANGLE(TED,ND,R,MJTA,PHI,PHI_1,PHI_2,
     &	PHI_MAT,PHI_MAT_1,PHI_MAT_2)
     
	DOUBLE PRECISION TED(3),ND(3),R(9),MJTA(12,9)
	DOUBLE PRECISION PHI(12),PHI_1(12),PHI_2(12)
	DOUBLE PRECISION PHI_MAT,PHI_MAT_1,PHI_MAT_2
	DOUBLE PRECISION TED_M2(3),ND_M2(3),TJMA(12,9)
	DOUBLE PRECISION TED_M2T(3),ND_M2T(3)
	DOUBLE PRECISION TRANSIT(9),TRANSIT_INV(9)
	INTEGER I_1,J_1,J_2
	DOUBLE PRECISION H,K,L,U,V,W
	DOUBLE PRECISION H1,K1,L1,U1,V1,W1
C CALCULATE TED IN GRAIN 2:::::::[M2;TED_M2]=(M2 J M1)[M1;TED]
C
C 	     GRAIN_2 M_2	(M2 J M1)	GRAIN_1 M_1
C	|TED_M2(1) ND_M2(1)| |R(1) R(2) R(3)| |TED(1) ND(1)|
C	|TED_M2(2) ND_M2(2)|=|R(4) R(5) R(6)|*|TED(2) ND(2)|
C	|TED_M2(3) ND_M2(3)| |R(7) R(8) R(9)| |TED(3) ND(3)|
C
C CALCULATE TED IN TWINS IN GRAIN 2 
C	[T;TED_M2T]=(T J M2)[M2;TED_M2]=(TJMA)[M2;TED_M2]
C	
C	|TED_M2T(1) ND_M2T(1)| |TJMA(1) TJMA(2) TJMA(3)| |TED_M2(1) ND_M2(1)|
C	|TED_M2T(2) ND_M2T(2)|=|TJMA(4) TJMA(5) TJMA(6)|*|TED_M2(2) ND_M2(2)|
C	|TED_M2T(3) ND_M2T(3)| |TJMA(7) TJMA(8) TJMA(9)| |TED_M2(3) ND_M2(3)|
C
	TED_M2(1)=R(1)*TED(1)+R(2)*TED(2)+R(3)*TED(3)
	TED_M2(2)=R(4)*TED(1)+R(5)*TED(2)+R(6)*TED(3)
	TED_M2(3)=R(7)*TED(1)+R(8)*TED(2)+R(9)*TED(3)
	
	ND_M2(1)=R(1)*ND(1)+R(2)*ND(2)+R(3)*ND(3)
	ND_M2(2)=R(4)*ND(1)+R(5)*ND(2)+R(6)*ND(3)
	ND_M2(3)=R(7)*ND(1)+R(8)*ND(2)+R(9)*ND(3)
	
	CALL NORM(ND_M2)
	CALL NORM(TED_M2)	
C	=======CALCULATE EULER ANGLE OF MATRIX=====
	H1=ND_M2(1)
	K1=ND_M2(2)
	L1=ND_M2(3)
	U1=TED_M2(1)
	V1=TED_M2(2)
	W1=TED_M2(3)

	PHI_MAT=360/6.2832*ACOS(L1)
	PHI_MAT_2=360/6.2832*ACOS(K1/DSQRT(H1*H1+K1*K1))
	PHI_MAT_1=360/6.2832*ACOS(DSQRT(1-W1*W1/(H1*H1+K1*K1)))
C	==========	
	   IF (PHI_MAT .GT. 90) THEN
	      PHI_MAT=180-PHI_MAT
	   ENDIF
C	==========	
	   IF (PHI_MAT_2 .GT. 90) THEN
	      PHI_MAT_2=180-PHI_MAT_2
	   ENDIF	
C	==========	
	   IF (PHI_MAT_1 .GT. 90) THEN
	      PHI_MAT_1=180-PHI_MAT_1
	   ENDIF	
C	==========
C     	=======EULER ANGLE OF MATRIX DONE==========
	
	DO 1 I_1 = 1,12
C          =======FIND OUT THE 	TJMA======
	   DO 2 J_1 = 1,9
		TRANSIT(J_1)=MJTA(I_1,J_1)
2	   CONTINUE
C
	   CALL INVERSE(TRANSIT,TRANSIT_INV)
C
	   DO 3 J_2 = 1,9
	   	TJMA(I_1,J_2)=TRANSIT_INV(J_2)
3	   CONTINUE
C	   =======TJMA HAS BEEN FOUND=====
C	   =======FIND OUT THE TED_M2T====
	   TED_M2T(1)=TJMA(I_1,1)*TED_M2(1)+TJMA(I_1,2)*TED_M2(2)+
     &		      TJMA(I_1,3)*TED_M2(3)
	   TED_M2T(2)=TJMA(I_1,4)*TED_M2(1)+TJMA(I_1,5)*TED_M2(2)+
     &		      TJMA(I_1,6)*TED_M2(3)
	   TED_M2T(3)=TJMA(I_1,7)*TED_M2(1)+TJMA(I_1,8)*TED_M2(2)+
     &		      TJMA(I_1,9)*TED_M2(3)	  
C	   =======FIND OUT THE ND_M2T=====	  
	   ND_M2T(1)=TJMA(I_1,1)*ND_M2(1)+TJMA(I_1,2)*ND_M2(2)+
     &		     TJMA(I_1,3)*ND_M2(3)
	   ND_M2T(2)=TJMA(I_1,4)*ND_M2(1)+TJMA(I_1,5)*ND_M2(2)+
     &		     TJMA(I_1,6)*ND_M2(3)
	   ND_M2T(3)=TJMA(I_1,7)*ND_M2(1)+TJMA(I_1,8)*ND_M2(2)+
     &		     TJMA(I_1,9)*ND_M2(3)	  
	  	  
	   CALL NORM(ND_M2T)
	   	H=ND_M2T(1)
	   	K=ND_M2T(2)
	   	L=ND_M2T(3)
	   CALL NORM(TED_M2T)
	   	U=TED_M2T(1)
	   	V=TED_M2T(2)
	   	W=TED_M2T(3)
C	   =======TED_M2T AND ND_M2T FOUND========
C	   =======CALCULATE PHI, PHI_1, PHI_2=====
C	   =======EQ.FROM PROF. LEE DONG NYUNG====
	   PHI(I_1)=360/6.2832*ACOS(L)
	   PHI_2(I_1)=360/6.2832*ACOS(K/DSQRT(H*H+K*K))
	   PHI_1(I_1)=360/6.2832*ACOS(DSQRT(1-W*W/(H*H+K*K)))
C	==========	
	   IF (PHI(I_1) .GT. 90) THEN
	      PHI(I_1)=180-PHI(I_1)
	   ENDIF
C	==========	
	   IF (PHI_2(I_1) .GT. 90) THEN
	      PHI_2(I_1)=180-PHI_2(I_1)
	   ENDIF	
C	==========	
	   IF (PHI_1(I_1) .GT. 90) THEN
	      PHI_1(I_1)=180-PHI_1(I_1)
	   ENDIF
C	==========	   
1	CONTINUE
C	======EXIT PROGRAM=====
	RETURN
	END

C=======================================================================
C=======================================================================
	SUBROUTINE STRAINENERGY(SMF,TENSOR,H,U)
     	DOUBLE PRECISION SMF,TENSOR(9),H(3),U(3)
     	DOUBLE PRECISION T(3),TH(3),TH_P(3),STRAIN_MAX,DOT1
     	
C	'H' TWINNING PLANE NORMAN
C	'U' TWINNING DIRECTION
C	==========CALCULATE [T1 T2 T3]
	CALL NORM(H)
	CALL NORM(U)
C	
	CALL MATRIX_VECTOR(TENSOR,H,T)
	IF ((T(1) .EQ. H(1)).AND.(T(2) .EQ. H(2)).AND.(T(3) .EQ. H(3)))
     &THEN
     		DOT1=0.0
     	ELSE	
		CALL CROSS(T,H,TH)
		CALL CROSS(H,TH,TH_P)
		CALL NORM(TH_P)
		CALL DOT(T,TH_P,STRAIN_MAX)
		CALL DOT(TH_P,U,DOT1)
	ENDIF
	SMF=DOT1*STRAIN_MAX
	
C	
C	DOT1 = A(1)*H(1)+A(2)*H(2)+A(3)*H(3)
C	DOT2 = A(1)*U(1)+A(2)*U(2)+A(3)*U(3)
C	SMF = SIG*DOT1*DOT2

	RETURN
	END
		
C=======================================================================
C=======================================================================
	SUBROUTINE CROSS(A,B,C)
	DOUBLE PRECISION A(3),B(3),C(3)
C	===INPUT:  A(3),B(3)====
C	===OUTPUT:    C(3)  ====	
	C(1)=A(2)*B(3)-A(3)*B(2)
	C(2)=A(3)*B(1)-A(1)*B(3)
	C(3)=A(1)*B(2)-A(2)*B(1)
	
	RETURN
	END
C=======================================================================
C=======================================================================
	SUBROUTINE DOT(A,B,C)
	DOUBLE PRECISION A(3),B(3)
	DOUBLE PRECISION C
C	===INPUT:  A(3),B(3)====
C	===OUTPUT:     C    ====
	C=A(1)*B(1)+A(2)*B(2)+A(3)*B(3)	
	
	RETURN
	END
C=======================================================================
C=======================================================================
	SUBROUTINE MATRIX_VECTOR(A,B,C)
	DOUBLE PRECISION A(9),B(3),C(3)
C	===INPUT:  A(9),B(3)====
C	===OUTPUT:   C(3)   ====		
	C(1)=A(1)*B(1)+A(2)*B(2)+A(3)*B(3)
	C(2)=A(4)*B(1)+A(5)*B(2)+A(6)*B(3)	
	C(3)=A(7)*B(1)+A(8)*B(2)+A(9)*B(3)	
	
	RETURN
	END
C=======================================================================
C=======================================================================
	SUBROUTINE MATRIX_MATRIX(A,B,C)
	DOUBLE PRECISION A(9),B(9),C(9)
C	====INPUT: A(9),B(9)====
C	====OUTPUT:   C(9)  ====
	C(1)=A(1)*B(1)+A(2)*B(4)+A(3)*B(7)
	C(2)=A(1)*B(2)+A(2)*B(5)+A(3)*B(8)
	C(3)=A(1)*B(3)+A(2)*B(6)+A(3)*B(9)	
	C(4)=A(4)*B(1)+A(5)*B(4)+A(6)*B(7)	
	C(5)=A(4)*B(2)+A(5)*B(5)+A(6)*B(8)	
	C(6)=A(4)*B(3)+A(5)*B(6)+A(6)*B(9)	
	C(7)=A(7)*B(1)+A(8)*B(4)+A(9)*B(7)	
	C(8)=A(7)*B(2)+A(8)*B(5)+A(9)*B(8)	
	C(9)=A(7)*B(3)+A(8)*B(6)+A(9)*B(9)
	
	RETURN
	END	

C=======================================================================
C=======================================================================
C Subroutine to compute the inverse of a matrix
C 'INV': components of (M1 J M2)
C 'R': components of (M2 J M1)
C 'DET': determinant

C|R(1) R(2) R(3)|				  |INV(1) INV(2) INV(3)|
C|R(4) R(5) R(6)| The inverse for this matrix is: |INV(4) INV(5) INV(6)|
C|R(7) R(8) R(9)|				  |INV(7) INV(8) INV(9)|
C REFERENCE:

C INPUT PARAMETER: R(9)
C OUTPUR PARAMETER: INV(9)

	SUBROUTINE INVERSE(R,INV)
C Argument declaration
	DOUBLE PRECISION R(9),INV(9)
C Local declaration
	DOUBLE PRECISION DET
C
	DET=R(1)*R(5)*R(9)+R(2)*R(6)*R(7)+R(3)*R(4)*R(8)
     &	    -R(1)*R(6)*R(8)-R(2)*R(4)*R(9)-R(3)*R(5)*R(7)
		INV(1)=(R(5)*R(9)-R(6)*R(8))/DET
		INV(2)=(R(3)*R(8)-R(2)*R(9))/DET
		INV(3)=(R(2)*R(6)-R(3)*R(5))/DET
		INV(4)=(R(6)*R(7)-R(4)*R(9))/DET
		INV(5)=(R(1)*R(9)-R(3)*R(7))/DET
		INV(6)=(R(3)*R(4)-R(1)*R(6))/DET
		INV(7)=(R(4)*R(8)-R(5)*R(7))/DET
		INV(8)=(R(2)*R(7)-R(1)*R(8))/DET
		INV(9)=(R(1)*R(5)-R(2)*R(4))/DET
	
C	WRITE (*,10) INV(1),INV(2),INV(3),INV(4),INV(5),INV(6),INV(7),
C    &		     INV(8),INV(9)
C10	FORMAT (/ 2x, 'the inverse of (M2 J M1)''=(M1 J M2) is: '
C&		/ 2X,'|', 3F8.4,'|'/ 2X,'|',3F8.4,'|'/ 2X,'|',3F8.4,'|')

	RETURN
	END
C=======================================================================
C=======================================================================
	SUBROUTINE SIMILARITY_MATRIX(A,B,C)
	DOUBLE PRECISION A(9),B(9),C(9),INV_A(9),TEMP(9)
C	==== A:     (M2 J M1)----INPUT
C	==== B:     (M1 T M1)----INPUT
C	==== C:     (M2 T M2)----OUTPUT
C	==== INV_A: (M1 J M2)----TEMP ASSIGN
C	==== TEMP:  TEMPORARY ASSIGNMENT
C	==== (M2 T M2) = (M2 J M1)*(M1 T M1)*(M1 J M2) = C = A * B * D

	CALL MATRIX_MATRIX(A,B,TEMP)
	CALL INVERSE(A,INV_A)
	CALL MATRIX_MATRIX(TEMP,INV_A,C)
	
	RETURN
	END

